let updateProductMap = {};
let id = "";
let commentsMap = {};

let times = null;
let searchList = [];
let nextPageBool = false;
var NOSHOW = true;
let pages = null;
let UpdateTime;
var unicorn = null,
  signToken;
let tableTime = null;
let endAsin = null;

const updateProduct = (info, id) => {
  // if(Object.values(updateProductMap).length>10)return
  if (id) {
    updateProductMap[id] = info;
  }
  return (params) => {
    let obj = {
      push_data: [],
      token: signToken,
    };
    const asinArr = [];
    const {
      cache = false,
      // async = false,
      method = "GET",
      dataType = "json",
      contentType = "application/json",
      ...val
    } = params;
    clearTimeout(UpdateTime);
    UpdateTime = setTimeout(() => {
      let endTag = false;

      if (endAsin) {
        for (const k in updateProductMap) {
          if (k === endAsin) {
            endTag = true;
            break;
          }
          if (endTag) {
            asinArr.push(updateProductMap[k]);
          }
        }
      }
      if (endAsin) {
        obj.push_data = asinArr;
      } else {
        obj.push_data = Object.values(updateProductMap);
      }
      // console.log(Object.keys(updateProductMap)[Object.keys(updateProductMap).length-1])
      endAsin =
        Object.keys(updateProductMap)[Object.keys(updateProductMap).length - 1];
      obj.token = signToken;
      val.data = JSON.stringify(obj);
      updateProductMap = {};
      endTag = false;

      $.ajax({
        method,
        cache,
        contentType,
        dataType,
        // async,
        ...val,
      });
    }, 8000);
  };
};
const renderTable = (tbody) => {
  clearTimeout(tableTime);
  tableTime = setTimeout(() => {
    // console.log("renderTable");
    $("#uniPopupPro #results-table tbody").html(tbody);
  }, 2000);
};
const chromeStorageType = {
  set: (name, data, fn = () => { }) => {
    chrome.storage.local.set({ [name]: data }, fn);
  },
  get: (name, fn = () => { }) => {
    chrome.storage.local.get(name, fn);
  },
  remove: (keys, fn = () => { }) => {
    chrome.storage.local.remove(keys, fn);
  },
};
sessionStorage.removeItem("onGetComments");
sessionStorage.removeItem("loading");
sessionStorage.removeItem("unicorn_Dowbload");
sessionStorage.removeItem("unicorn_close");
$.tablesorter.addParser({
  //对表格进行排序
  id: "numberWithCommas",
  is: function (s) {
    return false;
  },
  format: function (s) {
    var num = s.replace(/[\$\€\£]*/, "").replace(/,/g, "");
    //  num = s.replace(/\£/, '').replace(/,/g, '');
    //  num = s.replace(/\€/, '').replace(/,/g, '');
    //		if(s.indexOf('£')> -1) num = s.replace(/[\$€£,]*/, '')
    if (num == "< 5") num = 0.00001;
    if (num == "-") num = 0;

    return num;
  },
  type: "numeric",
});

//保存关键词
function saveKeyword(keyword, domain) {
  $.ajax({
    url: `${unicorn.amazon.URL[unicorn.amazon.env]}keyword/addKeyword`,
    // url: "https://unicornsmasherpro.com/api/keyword/addKeyword",
    //  https://unicornsmasherpro.com/api/keyword/addKeyword
    method: "POST",
    cache: false,
    "Content-Type": "application/json",
    data: {
      domain: domain,
      keyword: keyword,
      token: signToken,
    },
    error: function (jqXHR, textStatus, errorThrown) {
      //by ouyang
      //console.log(jqXHR, textStatus, errorThrown)
    },
    success: function (data) {
      // console.log(data)
    },
  });
}
var list = true;
chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
  // console.log("接受打开页面",request)
  if (request.uniMessage == "starts") {
    if (NOSHOW) {
      $("#uniPopupPro").show();
      //当页面接收信息成功且参数值为start时
      // let value = await chrome.storage.local.get('listenerList')
      // if (!value.listenerList) {
      if (list) {
        // $("#uniPopupPro").show();
        $("#uniPopupPro").removeClass("opacity0");
        // if (!unicorn) {
        //   unicorn = new UnicornPopup(); //新创建UnicornPopup方法
        // } else{
        //   unicorn.search.scrapeProducts("refresh")
        unicornRender(); //数据渲染
        // }
        advertisingAjax();
        //   if (!unicorn) {
        // unicorn = new UnicornPopup(); //新创建UnicornPopup方法
        //   } else if (unicorn.search.url !== document.URL) {
        //     if (document.URL.indexOf("/dp/") > -1)
        //       unicorn.search.scrapeProducts("refresh");
        //     else unicorn.search.scrapeProducts("refresh"); //刷新重新抓取数据
        // unicornRender(); //数据渲染
        //   }
        //   $("#uniPopupPro").show(); //unicorn smasher弹出框弹出
        // if (request.data && request.data.analyticsPrompt) {
        //   //首次使用时
        //   unicorn.showAnalyticsPrompt(); //首次安装出现提示框
        // }
        // advertisingAjax();
        // } else {
        //   $("#uniPopupPro").css("display", "none");
        // chrome.storage.local.set({'listenerList':true})
      }
      list = !list;
      $(".unicorn_advertising").hide();
      saveKeyword(unicorn.search.keywords, unicorn.search.domain);
      sendResponse({});
      return true;
    } else {
      unicorn = new UnicornPopup(); //新创建UnicornPopup方法
      sendResponse({});
      return true;
    }
  }
});

var uniDragPos = [-1, -1];
$("#uniPopupPro .block_friday_show .block_friday_show_close").on(
  "click",
  function (e) {
    $("#uniPopupPro .block_friday_show").css("display", "none");
    e.preventDefault();
  }
);
let UnicornPopup = function () {
  var self = this;
  this.amazon = amazon(document.URL); //new 构建函数,对应contants.js
  if (this.amazon.search.supported && NOSHOW) {
    //是否为搜索结果页网址，对应contants.js781行的search方法

    if (document.URL.substr(0, 6) == "https:" && !this.amazon.sslSupported) {
      //当站点不是我们所支持的ssl
      alert(
        "Unicorn Smasher is not compatible with SSL on " +
        window.location.hostname +
        ". We're redirecting you now.\nPlease click the Unicorn Smasher icon again once the redirect is complete."
      );
      window.location.replace(document.URL.replace("https:", "http:"));
      return;
    }

    this.start = 0;
    this.search = new UnicornSearch(document.URL); //new 构建函数,对应search.js
    this.search.ajaxCompleteCallback = unicornRender;

    // Get popup template & start smashing
    const oFragmeng = document.createDocumentFragment();
    $.get(chrome.runtime.getURL("/popup.html"), function (data) {
      //获取插件的正常页面
      const div = document.createElement("div");
      div.innerHTML = data;
      oFragmeng.append(div);
      // document.body.appendChild(oFragmeng);
      self.popupTemplate = oFragmeng; //插入页面
      unicornRender(); //插入数据

      //It's time to disappear
      var schedule_time = Date.parse(new Date("2017/12/21"));
      var now_time = Date.parse(new Date());

      if (schedule_time >= now_time) {
        //当前的时间戳小于规定的时间，显示宣传图片
        $("#uniPopupPro  .skip").on("click", function (e) {
          e.preventDefault();
          var language = navigator.browserLanguage
            ? navigator.browserLanguage
            : navigator.language;
          if (language.indexOf("zh") != -1) {
            //判断语言
            window.open(
              "https://intercom.help/amztracker/international-help-center-%E4%B8%AD%E6%96%87%E7%89%88/%E6%B4%BB%E5%8A%A8%E9%80%9A%E7%9F%A5/vipon-%E5%9C%A3%E8%AF%9E%E5%A4%A7%E4%BF%83%E6%B4%BB%E5%8A%A8%E4%BA%A7%E5%93%81%E5%BE%81%E9%9B%86%E6%AD%A3%E5%BC%8F%E5%BC%80%E5%90%AF"
            );
          } else {
            window.open(
              "https://intercom.help/amztracker/help-center/updates-and-offers/vipon-christmas-special-sale-updated"
            );
          }
        });
        var timer = setInterval(function () {
          //定时关闭宣传图片
          var html_number =
            parseInt(
              $(
                "#uniPopupPro .block_friday_show .block_friday_show_top div span:nth-child(2)"
              ).html()
            ) - 1;
          if (html_number >= 0) {
            $(
              "#uniPopupPro .block_friday_show .block_friday_show_top div span:nth-child(2)"
            ).html(html_number);
          } else {
            clearInterval(timer);
            //          $('#uniPopupPro').css('overflow-y','scroll');
            $("#uniPopupPro .block_friday_show").css("display", "none");
          }
        }, 1000);
        $("#uniPopupPro .block_friday_show .block_friday_show_close").on(
          "click",
          function (e) {
            e.preventDefault();
            //        $('#uniPopupPro').css('overflow-y','scroll');
            $("#uniPopupPro .block_friday_show").css("display", "none");
          }
        );
      } else {
        // $('#uniPopupPro').css('overflow-y','scroll');//表单可以滚动
        $("#uniPopupPro .block_friday_show").css("display", "none"); //隐藏宣传页
      }
      // const str = $("#unicorn_modal")[0].outerHTML;
      // $("body")[0].innerHTML += str;
      // $("#uniPopupPro #unicorn_modal").remove();
      $("#uniPopupPro").addClass("opacity0");
    });
    $.get(chrome.runtime.getURL("/modal.html"), function (data) {
      $("body").append($.parseHTML(data));
      $("body").append(
        $.parseHTML(
          `<div class="maximize-popup" style="opacity:0;"><div class="logo max"></div></div>`
        )
      );
    });
    $.get(chrome.runtime.getURL("/modalChart.html"), function (data) {
      $("body").append($.parseHTML(data));
    });
  } else {
    if ($("#uniPopupPro").length) {
      return;
    }
    // Show error popup
    $.get(chrome.runtime.getURL("/error.html"), function (data) {
      $("body").append(data);
      chrome.storage.local.get("hideOnPage", function (val) {
        //获取是否隐藏了onpage
        if (!val.hideOnPage || val.hideOnPage == 1) {
          $(".onpage-hide").show();
        } else {
          $(".onpage-show").show();
        }
        $(".onpage-hide").on("click", function () {
          //隐藏onpage
          chrome.storage.local.set(
            {
              hideOnPage: "0",
            },
            function () {
              $(".onpage-hide").hide();
              $(".onpage-show").show();
              $("#amztrackerOnpage").css("display", "none");
            }
          );
        });
        $(".onpage-show").on("click", function () {
          //展示onpage
          chrome.storage.local.set(
            {
              hideOnPage: "1",
            },
            function () {
              $(".onpage-show").hide();
              $(".onpage-hide").show();
              location.reload();
            }
          );
        });
      });

      //获取时间戳
      var schedule_time = Date.parse(new Date("2017/12/21"));
      var now_time = Date.parse(new Date());

      if (schedule_time >= now_time) {
        //当当前的时间戳小于规定的时间，显示宣传图片
        //跳转到tracker首页，根据游览器判断中英文
        $(".block_friday_unicorn").on("click", function (e) {
          var language = navigator.browserLanguage
            ? navigator.browserLanguage
            : navigator.language;
          if (language.indexOf("zh") != -1) {
            //判断语言
            window.open(
              "https://intercom.help/amztracker/international-help-center-%E4%B8%AD%E6%96%87%E7%89%88/%E6%B4%BB%E5%8A%A8%E9%80%9A%E7%9F%A5/vipon-%E5%9C%A3%E8%AF%9E%E5%A4%A7%E4%BF%83%E6%B4%BB%E5%8A%A8%E4%BA%A7%E5%93%81%E5%BE%81%E9%9B%86%E6%AD%A3%E5%BC%8F%E5%BC%80%E5%90%AF"
            );
          } else {
            window.open(
              "https://intercom.help/amztracker/help-center/updates-and-offers/vipon-christmas-special-sale-updated"
            );
          }
        });
        $("#uniPopupPro .block_friday_picture_error .count_down a").on(
          "click",
          function (e) {
            e.preventDefault();
            $("#help-screen").css("display", "block");
            $("#uniPopupPro .block_friday_picture_error").css(
              "display",
              "none"
            );
          }
        );
        var timer = setInterval(function () {
          //定时关闭宣传图片
          var html_number =
            parseInt(
              $(
                "#uniPopupPro .block_friday_picture_error .count_down div span:nth-child(2)"
              ).html()
            ) - 1;
          if (html_number >= 0) {
            $(
              "#uniPopupPro .block_friday_picture_error .count_down div span:nth-child(2)"
            ).html(html_number);
          } else {
            clearInterval(timer);
            $("#help-screen").css("display", "block");
            $("#uniPopupPro .block_friday_picture_error").css(
              "display",
              "none"
            );
          }
        }, 1000);
      } else {
        $("#help-screen").css("display", "block"); //表单可以滚动
        $("#uniPopupPro .block_friday_picture_error").css("display", "none"); //隐藏宣传页
      }

      $("#uniPopupPro .close-popup").click(function () {
        //关闭插件页面
        $("#uniPopupPro").remove();
      });
    });
  }
};

UnicornPopup.prototype.showAnalyticsPrompt = function () {
  //当首次安装插件点击图标时
  var timer = setInterval(function () {
    if ($("#overlay-wrap")[0]) {
      clearInterval(timer);
      $("#uniPopupPro").addClass("analyticsPrompt");
      $("#overlay-wrap").fadeIn();
      $("#btn-cpa-allow").click(function (e) {
        // chrome.runtime.sendMessage({
        //   cmd: "cpa.toggle",
        //   data: true,
        // }); //发送消息，保存不是不用再显示
        $("#uniPopupPro").removeClass("analyticsPrompt");
        $("#overlay-wrap").hide();
      });
      $("#btn-cpa-deny").click(function (e) {
        // chrome.runtime.sendMessage({
        //   cmd: "cpa.toggle",
        //   data: false,
        // }); //发送消息，
        $("#uniPopupPro").removeClass("analyticsPrompt");
        $("#overlay-wrap").hide();
      });
    }
  }, 100);
}.bind(this);

UnicornPopup.prototype.nextPage = function () {
  nextPageBool = true;
  this.unicorn.search.scrapeProducts(undefined, "next"); //加载下一页数据
  unicornRender(); //更新数据
  // chrome.runtime.sendMessage({
  //   //保存数据
  //   cmd: "cpa.sendEvent",
  //   data: ["us", "next-page"],
  // });
}.bind(this);
const toCsvValue = (value) => {
  return value.toString().replace(',', '').replace(/[\r\n]/g, "")//.replace('-','');
}
UnicornPopup.prototype.toCSV = async function () {
  $("#uniPopupPro #btn-csv").hide();
  //输出CSV文件
  let data = [];
  let str = `No.,Product,Link,Brand,Sellers,Price,Discount,Category,Rank,D. Sales,Mo. Sales,Mo.Revenue,Reviews,Rate of reviews,Rating,FBA,Date,\n`;
  // if (document.URL.indexOf("/dp/") > -1) data = unicorn.search.multiPage;
  // else data = unicorn.search.products;
  // localStorage.getItem('product'+umicorn.search.domain+umicorn.search.pageNext,unicorn.search.nowProducts)
  for (let index = 0; index < 1000; index++) {
    // if(index <= unicorn.search.pageNext ){
    let value = await localforage.getItem('product' + unicorn.search.domain + index);
    if (value) {
      data = data.concat(JSON.parse(value))
    }
    // }
    // if(sessionStorage.getItem('product'+unicorn.search.domain+index)){
    //   data = data.concat(JSON.parse(sessionStorage.getItem('product'+unicorn.search.domain+index)))
    // }
  }
  // console.log("解析数据", data)
  let brand = null;
  let proData = data.map((item, index) => {
    brand = item.brand.replace(
      /(Visit the |Brand: |Store|Marke:|Marque :|Visiter la boutique|Visita la de|Visita la Store de|Marca:|Visita lo  di |Visita lo Store di )/gi,
      ""
    );
    let sales = "-";
    let revenue = "-";
    let moReviews = "-";
    if ($.isNumeric(item.sales)) {
      if (helper.toNumber(item.sales) <= 5) {
        sales = '< 5';
      } else {
        sales = helper.numberWithCommas(item.sales);
      }
    }
    if ($.isNumeric(item.revenue)) {
      if (helper.toNumber(item.sales) <= 5) {
        revenue = item.currency + helper.numberWithCommas(Math.round(helper.toNumber(item.price) * 5))
      } else {
        revenue = item.currency + helper.numberWithCommas(item.revenue)
      }
    }
    if ($.isNumeric(item.moReviews) && $.isNumeric(helper.toNumber(item.sales))) {
      let score = null;
      if (helper.toNumber(item.sales) && item.moReviews) {
        score = (
          (item.moReviews / helper.toNumber(item.sales)) *
          100
        ).toFixed(0);
      } else {
        score = "-";
      }
      moReviews = !isNaN(score) ? (score != 0 ? score : "1") : 0 + "%"
    }
    return {
      'No.': index,
      'Product': item.title ? toCsvValue(item.title) : '-',
      'Link': item.url ? toCsvValue(item.url) : '-',
      'Brand': toCsvValue(brand),
      'Sellers': item.sellersNew ? toCsvValue(item.sellersNew) : '-',
      'Price': helper.isNum(item.price) ? toCsvValue(item.price) : '-',
      'Discount': item.Coupon ? toCsvValue(item.Coupon) : '-',
      'Category': item.category ? toCsvValue(item.category) : "-",
      'Rank': item.salesRank ? toCsvValue(item.salesRank) : '-',
      'D. Sales': $.isNumeric(item.daily_sales) ? toCsvValue(helper.numberWithCommas(item.daily_sales)) : '-',
      'Mo. Sales': toCsvValue(sales),
      'Mo.Revenue': toCsvValue(revenue),
      'Reviews': item.reviews ? toCsvValue(item.reviews) : '-',
      'Rate of reviews': toCsvValue(moReviews),
      'Rating': item.rating ? toCsvValue(item.rating) : '-',
      'FBA': item.fba ? toCsvValue(item.fba) : '-',
      'Date': item.date ? toCsvValue(item.date) : '-',
    }
  })
  for (let i = 0; i < proData.length; i++) {
    for (const key in proData[i]) {
      str += `"${proData[i][key] + '\t'}",`;
    }
    str += '\r\n';
  }
  // encodeURIComponent解决中文乱码
  const uri = 'data:text/csv;charset=utf-8,\ufeff' + encodeURIComponent(str);
  // 通过创建a标签实现
  const link = document.createElement("a");
  link.href = uri;
  // 对下载的文件命名
  link.download = this.unicorn.search.keywords + " " + this.unicorn.search.domain + ".csv";
  link.click();
  $("#uniPopupPro #btn-csv").show();
  return
  var td = $("#uniPopupPro #results-table tbody .td-title"); //获取标题表元素
  var ahtml = [];
  $.each(td, function (index, td) {
    ahtml[index] = $(td).html();
    $(td).html($(td).find("a").html().replace("<br>", "\n")); //为导出CSV做准备
  });

  //$('#uniPopupPro .td-variations').show();//为导出CSV做准备
  $("#uniPopupPro .td-link").show(); //为导出CSV做准备

  $("#uniPopupPro .td-checkbox").hide();
  var csv = $("#uniPopupPro #results-table").table2CSV({
    delivery: "value",
  }); //配置导出CSV文件的第三方库，delivery属性值随便设置，只要不等于popup
  var filename =
    this.unicorn.search.keywords + " " + this.unicorn.search.domain + ".csv"; //下载文件名
  // console.log(csv)
  var location =
    "data:application/csv;charset=UTF-8," + encodeURIComponent(csv); //下载文件格式及内容
  $.each(td, function (index, td) {
    $(td).html(ahtml[index]);
  });

  //$('#uniPopupPro .td-variations').hide();//恢复
  $("#uniPopupPro .td-link").hide(); //恢复
  $("#uniPopupPro .td-checkbox").show();
  //创建一个a标签配置链接，触发点击，下载文件
  var pom = document.createElement("a");
  pom.setAttribute("href", location);
  pom.setAttribute("download", filename);

  if (document.createEvent) {
    //创建事件
    var event = document.createEvent("MouseEvents");
    //初始化点击事件
    event.initEvent("click", true, true);
    pom.dispatchEvent(event); //元素触发事件
  } else {
    pom.click();
  }

  // chrome.runtime.sendMessage({
  //   cmd: "cpa.sendEvent",
  //   data: ["us", "toCSV"],
  // });
}.bind(this);

UnicornPopup.prototype.updateFooter = async function () {
  var self = this;
  var rows = $("#uniPopupPro table#results-table>tbody>tr:visible");
  var tfoot = [];
  var priceTotal = 0;
  var rankTotal = 0;
  var salesTotal = 0;
  var revenueTotal = 0;
  var reviewsTotal = 0;
  var ratingTotal = 0;
  var variationsTotal = 0;
  var sellersNewTotal = 0;

  var categoryList = {};
  var finalCategoryCount = 0;
  var finalCategory = "";
  var currency = this.amazon.currency;
  var priceSort = [],
    rankSort = [],
    saleSort = [],
    revenueSort = [],
    ratingSort = [],
    reviewSort = [];
  $.each(rows, function (index, row) {
    if ($(row).find(".td-price span").html()) {
      priceTotal += helper.toNumber(
        $(row)
          .find(".td-price span")
          .html()
          .replace(currency, "")
          .replace(/^\D+/, "")
      ); //获取price的总数
      priceSort.push(
        helper.toNumber(
          $(row)
            .find(".td-price span")
            .html()
            .replace(currency, "")
            .replace(/^\D+/, "")
        )
      );
    }
    if (helper.toNumber($(row).find(".td-salesrank").html())) {
      rankTotal += helper.toNumber($(row).find(".td-salesrank").html()); //获取rank的总数
      rankSort.push(helper.toNumber($(row).find(".td-salesrank").html()));
    }
    if (self.amazon.salesSupported) {
      if (helper.toNumber($(row).find(".td-sales").html().replace("<", ""))) {
        salesTotal += helper.toNumber(
          $(row).find(".td-sales").html().replace("<", "")
        );
        saleSort.push(
          helper.toNumber($(row).find(".td-sales").html().replace("<", ""))
        );
      } //获取sales的总数
      if (
        helper.toNumber($(row).find(".td-revenue").html().replace(currency, ""))
      ) {
        revenueTotal += helper.toNumber(
          $(row).find(".td-revenue").html().replace(currency, "")
        ); //获取revenue的总数
        revenueSort.push(
          helper.toNumber(
            $(row).find(".td-revenue").html().replace(currency, "")
          )
        );
      }
    }

    if (helper.toNumber($(row).find(".td-reviews").html())) {
      reviewsTotal += helper.toNumber($(row).find(".td-reviews").html()); //获取sales的总数
      reviewSort.push(helper.toNumber($(row).find(".td-reviews").html()));
    }
    if (helper.toNumber($(row).find(".td-rating").html())) {
      ratingTotal += helper.toNumber($(row).find(".td-rating").html()); //获取sales的总数
      ratingSort.push(helper.toNumber($(row).find(".td-rating").html()));
    }
    //  variationsTotal += helper.toNumber($(row).find('.td-variations').html());//获取sales的总数
    sellersNewTotal += helper.toNumber($(row).find(".td-sellers").html()); //获取sales的总数
    category = $(row).find(".td-category").html();
    categoryList[category] = categoryList[category]
      ? categoryList[category] + 1
      : 1; //获取category的类名，并记录上每个类的出现的次数
  });

  $.each(categoryList, function (category, categoryCount) {
    if (categoryCount > finalCategoryCount) {
      finalCategory = category; //记录出现类的次数最多的类
      finalCategoryCount = categoryCount; //记录出现类的次数最多的类出现的次数
    }
  });
  //星星评分细则
  var saleRating = "",
    widthTal = $(".star-rating").width() / 5,
    grade = "",
    reviewRating = "",
    saleRatingAverage = parseFloat(salesTotal / rows.length).toFixed(0),
    reviewRatingAverage = parseFloat(reviewsTotal / rows.length).toFixed(0);
  if (saleRatingAverage) {
    //销量得分
    if (saleRatingAverage < 100) {
      saleRating = 1;
    } else if (saleRatingAverage >= 100 && saleRatingAverage < 200) {
      saleRating = 2;
    } else if (saleRatingAverage >= 200 && saleRatingAverage < 600) {
      saleRating = 3;
    } else if (saleRatingAverage >= 600 && saleRatingAverage < 2000) {
      saleRating = 4;
    } else if (saleRatingAverage >= 2000) {
      saleRating = 5;
    }
  }
  if (reviewRatingAverage) {
    //评论得分
    if (reviewRatingAverage < 100) {
      reviewRating = 5;
    } else if (reviewRatingAverage >= 100 && reviewRatingAverage < 250) {
      reviewRating = 4;
    } else if (reviewRatingAverage >= 250 && reviewRatingAverage < 500) {
      reviewRating = 3;
    } else if (reviewRatingAverage >= 500 && reviewRatingAverage < 1000) {
      reviewRating = 2;
    } else if (reviewRatingAverage >= 1000) {
      reviewRating = 1;
    }
  }
  var gradeDetail = (saleRating + reviewRating) / 2;
  if (gradeDetail <= 2) {
    grade = "Low";
  } else if (gradeDetail > 3) {
    grade = "High";
  } else {
    grade = "Medium";
  }
  $(".star-rating-top").width(((saleRating + reviewRating) / 2) * widthTal);
  $(".scored").html(grade);
  $(".star-rating")
    .addClass("has-tooltipPro")
    .attr("data-tooltipPro", (saleRating + reviewRating) / 2);
  if (rows.length > 0) {
    //计算数据的平均值
    tfoot.count = rows.length;
    tfoot.reviews = helper.numberWithCommas(
      parseFloat(reviewsTotal / reviewSort.length).toFixed(0)
    );
    //  tfoot.variations = helper.numberWithCommas(parseFloat(variationsTotal/rows.length).toFixed(0));
    //  tfoot.sellersNew = helper.numberWithCommas(parseFloat(sellersNewTotal/rows.length).toFixed(0));
    tfoot.rating = parseFloat(ratingTotal / ratingSort.length).toFixed(1);
    if (priceSort.length > 0) {
      tfoot.price =
        currency + parseFloat(priceTotal / priceSort.length).toFixed(2);
    }
    if (revenueSort.length > 0) {
      tfoot.revenue =
        currency +
        helper.numberWithCommas(
          parseFloat(revenueTotal / revenueSort.length).toFixed(0)
        );
    } else {
      tfoot.revenue = 0;
    }
    if (saleSort.length > 0) {
      tfoot.sales = helper.numberWithCommas(
        parseFloat(salesTotal / saleSort.length).toFixed(0)
      );
    } else {
      tfoot.sales = 0;
    }
    if (rankSort.length > 0) {
      tfoot.rank = helper.numberWithCommas(
        parseFloat(rankTotal / rankSort.length).toFixed(0)
      );
    } else {
      tfoot.rank = 0;
    }
  } else {
    tfoot.price = 0;
    tfoot.rank = 0;
    tfoot.sales = 0;
    tfoot.revenue = 0;
    tfoot.reviews = 0;
    tfoot.variations = 0;
    tfoot.rating = 0;
  }

  tfoot.category = finalCategory;
  //在表格尾部展示总条数；数据的平均值
  $("table#results-table>tfoot .td-rank").html(tfoot.count);
  $("table#results-table>tfoot .td-price,#priceSort>p").html(tfoot.price);
  $("table#results-table>tfoot .td-salesrank,#rankSort>p").html(tfoot.rank);
  $("table#results-table>tfoot .td-sales,#saleSort>p").html(tfoot.sales);
  $("table#results-table>tfoot .td-revenue,#revenueSort>p").html(tfoot.revenue);
  $("table#results-table>tfoot .td-reviews,#reviewSort>p").html(tfoot.reviews);
  $("table#results-table>tfoot .td-reviews,#pageNumber>p").html(self.search.pageNext - 1);
  // $("table#results-table>tfoot .td-reviews,#productNumber>p").html(productNumber);
  $("table#results-table>tfoot .td-rating,#ratingSort>p").html(tfoot.rating);
  $("table#results-table>tfoot .td-category").html(tfoot.category);
  $("table#results-table>tfoot .td-variations").html(tfoot.variations);
  $("table#results-table>tfoot .td-sellers").html(tfoot.sellersNew);

  if (this.search.activeAjaxCalls > 1) $("#uniPopupPro #footer .btn").hide();
  else $("#uniPopupPro #footer .btn").show();
};

UnicornPopup.prototype.clearFilters = function () {
  //清空筛选条件

  $("#uniPopupPro #filter input[name^=filter]").val("");
  $("#uniPopupPro #filter input[name=filter-fba]").prop("checked", false);
  $("#message").hide();
  $("#uniPopupPro #results-table tr").show();
};

UnicornPopup.prototype.filterTable = function () {
  //筛选条件后的结果

  var self = this;

  var rows = $("#uniPopupPro table#results-table>tbody>tr");
  var lables = $("#uniPopupPro #filter input:checked"),
    htmlFilter = "";
  var showCount = 0;
  $.each(rows, function (index, row) {
    var show = 1;
    $.each(lables, function (text, lable) {
      htmlFilter += $(lable).siblings("span").html();
      if (
        htmlFilter.indexOf($(row).find(".td-fba").children("div").html()) ==
        -1 ||
        $(row).find(".td-fba").children("div").html() == ""
      ) {
        show = 0;
      }
      self.search.filters.onlyFba = 1;
    });

    //判断是否显示这个tr
    show =
      show &
      self.filterInput("price", row) &
      self.filterInput("sellers", row) &
      self.filterInput("salesrank", row) &
      self.filterInput("sales", row) &
      self.filterInput("revenue", row) &
      self.filterInput("reviews", row) &
      self.filterInput("rating", row);

    if (show) {
      $(row).show(); //显示
      showCount++; //显示数加一
    } else {
      $(row).hide(); //隐藏
    }
  });

  if (showCount == 0) {
    $("#uniPopupPro #message").html("No products :(").show();
    $("#results-table thead").hide();
    $("#head-container").show();
  } //当没有满足条件的数据时，显示提示
  else {
    $("#uniPopupPro #message").hide();
    $("#results-table thead").show();
    // $("#head-container").hide();
  }

  this.updateFooter(); //更新表格尾部
};

UnicornPopup.prototype.filterInput = function (name, row) {
  //数据筛选

  var show = 1;

  var minMax = {
    min: "",
    max: "",
  };

  if (name == "sellers" || name == "price") {
    //当name是sellers price
    //var sellerCount = helper.toNumber( helper.regex( /(\d+)\b/i, $(row).find('.td-' + name).html() ) );
    //获取seller
    var sellerCount = helper.toNumber(
      helper.regex(
        /(\d[\d.,]*)\b/i,
        $(row)
          .find(".td-" + name)
          .html()
      )
    ); // 获取name的值
    if (
      $.isNumeric(
        $("#uniPopupPro #filter input[name=filter-" + name + "-min]").val()
      )
    ) {
      //当用户输入name的值存在
      if (
        sellerCount <
        helper.toNumber(
          $("#uniPopupPro #filter input[name=filter-" + name + "-min]").val()
        )
      )
        show = 0; //当前值小于最小值，show为0
      minMax.min = helper.toNumber(
        $("#uniPopupPro #filter input[name=filter-" + name + "-min]").val()
      );
    }

    if (
      $.isNumeric(
        $("#uniPopupPro #filter input[name=filter-" + name + "-max]").val()
      )
    ) {
      //当name的值存在
      if (
        sellerCount >
        helper.toNumber(
          $("#uniPopupPro #filter input[name=filter-" + name + "-max]").val()
        )
      )
        show = 0; //当前值小于最小值，show为0
      minMax.max = helper.toNumber(
        $("#uniPopupPro #filter input[name=filter-" + name + "-max]").val()
      );
    }
  } else {
    if (
      $.isNumeric(
        $("#uniPopupPro #filter input[name=filter-" + name + "-min]").val()
      )
    ) {
      //当前值小于最小值
      if (
        helper.toNumber(
          $(row)
            .find(".td-" + name)
            .html()
        ) <
        helper.toNumber(
          $("#uniPopupPro #filter input[name=filter-" + name + "-min]").val()
        )
      )
        show = 0;
      minMax.min = helper.toNumber(
        $("#uniPopupPro #filter input[name=filter-" + name + "-min]").val()
      );
    }

    if (
      $.isNumeric(
        $("#uniPopupPro #filter input[name=filter-" + name + "-max]").val()
      )
    ) {
      //当前值大于最大值
      if (
        helper.toNumber(
          $(row)
            .find(".td-" + name)
            .html()
        ) >
        helper.toNumber(
          $("#uniPopupPro #filter input[name=filter-" + name + "-max]").val()
        )
      )
        show = 0;
      minMax.max = helper.toNumber(
        $("#uniPopupPro #filter input[name=filter-" + name + "-max]").val()
      );
    }
  }

  this.search.filters[name] = minMax;
  return show;
};

UnicornPopup.prototype.toggleFavorite = function () {
  $("#uniPopupPro #search-favorite").toggleClass("fav");

  if ($("#uniPopupPro #search-favorite").hasClass("fav"))
    this.search.favorite = 1;
  else this.search.favorite = 0;

  this.search.storeResults();
};

UnicornPopup.prototype.signInAjax = function () {
  var then = this;
  $.ajax({
    type: "get",
    url: `${unicorn.amazon.URL[unicorn.amazon.env]}user/login`,
    data: {
      account: $(".account_input").val(),
      password: $(".password_input").val(),
    },
    xhrFields: {
      withCredentials: true,
    },
    cache: false,
    // dataType: "json/text",
    contentType: "application/json",
    complete: function (XMLHttpRequest, status) {
      //当请求完成时调用函数
      // console.log(XMLHttpRequest, status);
      /*if (status == 'timeout') {//status == 'timeout'意为超时,status的可能取值：success,notmodified,nocontent,error,timeout,abort,parsererror
        ajaxTimeOut.abort(); //取消请求
        Modal.warning({     //超时提示：网络不稳定
          title: '友情提示',
          content: '网络不稳定',
        });
      }*/
    },
    success: function (data) {
      if (data.code == 1) {
        if (data.data.userinfo.pay == 1) {
          signToken = data.data.userinfo.token;
          $("#mask").hide();
          $(".error").hide();
          localStorage.setExpire(
            "signToken",
            data.data.userinfo.token,
            1296000000
          );
          getData();
          $(".payLink").hide();
        } else if (data.data.userinfo.pay == 0) {
          $(".payLink").show();
          window.open("https://unicornsmasherpro.com/index/pay/index");
        }
      } else {
        // console.log(data.msg);
        if (data.msg) {
          $(".error").html("*" + data.msg);
        } else {
          $(".error").html("*" + "Please upgrade Google browser");
        }
      }
    },
    error: function (err) {
      console.log(err, err.msg);
    },
  });
}.bind(this);

function uniSetEvents() {
  commentEvents();
  chartEvents();
  $(".sign_button").unbind("click").click(unicorn.signInAjax);
  $(".password_input")
    .unbind("keydown")
    .on("keydown", function (event) {
      var e = event || window.event || arguments.callee.caller.arguments[0];
      if (e && e.keyCode == 13) {
        unicorn.signInAjax();
      }
    });
  $(".account_input")
    .unbind("keydown")
    .on("keydown", function (event) {
      var e = event || window.event || arguments.callee.caller.arguments[0];
      if (e && e.keyCode == 13) {
        $(".password_input").focus();
      }
    });
  $("#uniPopupPro .has-tooltipPro") //给添加了has-tooltipPro的需要提示的地方绑定鼠标事件
    .unbind("mouseenter mouseleave")
    .hover(
      function () {
        showtooltipPro($(this));
      },
      function () {
        $("#tooltipPro").offset({
          top: "-9999",
          left: "-9999",
        });
      }
    );

  $("#uniPopupPro #btn-next-page").unbind("click").click(function () {
    if ($('#message').css('display') == 'none') {
      unicorn.nextPage();
    }
  }); //下一页
  $("#uniPopupPro #btn-csv").unbind("click").click(unicorn.toCSV); //到处CSV文件
  $("#uniPopupPro #btn-help-center")
    .unbind("click")
    .click(function () {
      //新打开unicornsmasher网站
      window.open("https://help.unicornsmasherpro.com", "_blank");
      // chrome.runtime.sendMessage({
      //   //给谷歌发送消息
      //   cmd: "cpa.sendEvent",
      //   data: ["us", "toHelpCenter"],
      // });
    });

  $("#uniPopupPro #results-table .td-title") //鼠标进入和移除时，title的展示，产品图片的展示；移除恢复以前
    .unbind("mouseover")
    .unbind("mouseout")
    .on("mouseover", function () {
      //   $(".td-brand").hide();
      //    $('.td-sellers').hide();
      $(".td-title").addClass("expand");
      $("#uniPopupPro #product-details img").prop(
        "src",
        $(this).parent().data("image")
      );
      var tr = $(this).closest("tr");
      var lefts =
        $(tr).find(".td-price").offset().left - $("#uniPopupPro").offset().left;
      if (
        $("#uniPopupPro #footer").offset().top -
        $(tr).find(".td-price").offset().top >
        $("#uniPopupPro #product-details").height()
      ) {
        var tops =
          $(tr).find(".td-price").offset().top -
          $(tr).find(".td-price").height() / 2 +
          10 -
          $("#uniPopupPro").offset().top;
        $("#uniPopupPro #product-details")
          .css({
            bottom: "auto",
            top: tops,
            left: lefts,
          })
          .show();
      } else {
        var bottoms = $("#uniPopupPro #footer").height();
        $("#uniPopupPro #product-details")
          .css({
            bottom: bottoms,
            left: lefts,
            top: "auto",
          })
          .show();
      }

      $("#uniPopupPro #results td.td-title").width(
        $("#uniPopupPro #head-container th.td-title").width()
      );
    })
    .on("mouseout", function () {
      //   $(".td-brand").show();
      //    $('.td-sellers').show();
      $("#uniPopupPro #results td.td-title").width(
        $("#uniPopupPro #head-container th.td-title").width()
      );
      $(".td-title").removeClass("expand");
      $("#uniPopupPro #product-details")
        .css({
          top: -9999,
          left: -9999,
          bottom: "auto",
        })
        .hide();
    });
  // 移入显示大图
  $("#uniPopupPro #results-table .td-image") //鼠标进入和移除时，title的展示，产品图片的展示；移除恢复以前
    .unbind("mouseover")
    .unbind("mouseout")
    .on("mouseover", function () {
      // $(".td-brand").hide();
      //    $('.td-sellers').hide();
      // $(".td-image").addClass("expand");
      $("#uniPopupPro #product-details img").prop(
        "src",
        $(this).parent().data("image")
      );
      var tr = $(this).closest("tr");
      var lefts =
        $(tr).find(".td-price").offset().left - $("#uniPopupPro").offset().left;
      if (
        $("#uniPopupPro #footer").offset().top -
        $(tr).find(".td-price").offset().top >
        $("#uniPopupPro #product-details").height()
      ) {
        var tops =
          $(tr).find(".td-price").offset().top -
          $(tr).find(".td-price").height() / 2 +
          10 -
          $("#uniPopupPro").offset().top;
        $("#uniPopupPro #product-details")
          .css({
            bottom: "auto",
            top: tops,
            left: lefts,
          })
          .show();
      } else {
        var bottoms = $("#uniPopupPro #footer").height();
        $("#uniPopupPro #product-details")
          .css({
            bottom: bottoms,
            left: lefts,
            top: "auto",
          })
          .show();
      }

      $("#uniPopupPro #results td.td-image").width(
        $("#uniPopupPro #head-container th.td-image").width()
      );
    })
    .on("mouseout", function () {
      // $(".td-brand").show();
      //    $('.td-sellers').show();
      $("#uniPopupPro #results td.td-image").width(
        $("#uniPopupPro #head-container th.td-image").width()
      );
      // $(".td-image").removeClass("expand");
      $("#uniPopupPro #product-details")
        .css({
          top: -9999,
          left: -9999,
          bottom: "auto",
        })
        .hide();
    });

  $("#uniPopupPro #btn-filter,#uniPopupPro .close-filter")
    .unbind("click")
    .click(function () {
      //展示和隐藏筛选条件
      $("#uniPopupPro #filter").slideToggle(400).toggleClass("fadingOut");
    });

  $("#uniPopupPro #filter input")
    .unbind("change")
    .on("change", function () {
      //当筛选条件有变化时
      unicorn.filterTable();
    });

  $("#uniPopupPro #filter #btn-clear-filters")
    .unbind("click")
    .click(function () {
      //清空筛选条件
      unicorn.clearFilters();
    });

  $("#uniPopupPro #search-favorite")
    .unbind("click")
    .click(function () {
      //收藏时，保存收藏
      unicorn.toggleFavorite();
    });
  $("#uniPopupPro #trend")
    .unbind("click")
    .click(function () {
      //趋势页面跳转
      window.open(
        "https://trends.google.com/trends/explore?q=" + unicorn.search.keywords
      );
    });
  $("#uniPopupPro .close-popup")
    .unbind("click")
    .click(async function () {
      //隐藏插入页
      $("#uniPopupPro").hide();
      list = !list;
      // let value = await chrome.storage.local.get('listenerList')
      // if(value.listenerList){
      //   chrome.storage.local.set({'listenerList':false})
      // }else{
      //   chrome.storage.local.set({'listenerList':true})
      // }
      // chrome.runtime.sendMessage({
      //   cmd: "cpa.sendEvent",
      //   data: ["us", "closed"],
      // });
    });

  $("#uniPopupPro #refresh-search")
    .unbind("click")
    .click(function () {
      //刷新插入页
      $("#message").html("Analyzing...");
      $("#results-table .head-show").show();
      $("head-container").hide();
      if (document.URL.indexOf("/dp/") > -1)
        unicorn.search.multiProducts("refresh");
      else unicorn.search.scrapeProducts("refresh"); //刷新重新抓取数据
      $("#uniPopupPro #refresh-search").css(
        "animation",
        "rotation .5s linear infinite"
      );
      unicornRender(); //重新数据渲染
      // chrome.runtime.sendMessage({
      //   cmd: "cpa.sendEvent",
      //   data: ["us", "refreshed"],
      // });
    });
  $("#uniPopupPro #open-dashboard")
    .unbind("click")
    .click(function () {
      //打开Dashboard页面
      $("#search-favorite").click();
      chrome.runtime.sendMessage({
        action: "toDashboard",
      });
    });

  $("#uniPopupPro #btn-add-to-dashboard")
    .unbind("click")
    .click(function () {
      //保存数据
      unicorn.search.storeResults(); //存储数据
      chrome.runtime.sendMessage({
        action: "refreshSidebar",
      }); //向background发送带有action: "refreshSidebar"属性的消息
      $("#uniPopupPro #btn-add-to-dashboard").hide();
      $("#uniPopupPro #add-to-dashboard-check").show();
    });
  $("#uniPopupPro .dtas-img span")
    .unbind("click")
    .click(function () {
      window.open("http://www.dtas.com");
      ga("send", "event", "Dtas Link", "click", ""); //谷歌追踪代码
    });
  // 插件全屏
  $("#uniPopupPro .fullScreen_popup")
    .unbind("click")
    .click(function () {
      console.log("fullScreen_popup");
      $("#uniPopupPro").addClass("fullScreen_uniPopupPro");
      if ($("#results").scrollTop() > 0) {
        $("#uniPopupPro #results").height(
          $("#uniPopupPro").height() -
          $("#uniPopupPro #header").height() -
          $("#uniPopupPro #head-container").height() -
          $("#uniPopupPro #footer").height() -
          29
        );
        $("#barRight div:first-child").height(
          $("#uniPopupPro #results").height() - 20
        );
      } else {
        $("#uniPopupPro #results").height(
          $("#uniPopupPro").height() -
          $("#uniPopupPro #header").height() -
          $("#uniPopupPro #footer").height() -
          29
        );
        $("#barRight div:first-child").height(
          $("#uniPopupPro #results").height() - 70
        );
      }
      $(".restore_popup").show();
      $(".fullScreen_popup").hide();
    });
  // 恢复原大小
  $("#uniPopupPro  .restore_popup")
    .unbind("click")
    .click(() => {
      $("#uniPopupPro").removeClass("fullScreen_uniPopupPro");
      if ($("#results").scrollTop() > 0) {
        $("#uniPopupPro #results").height(
          $("#uniPopupPro").height() -
          $("#uniPopupPro #header").height() -
          $("#uniPopupPro #head-container").height() -
          $("#uniPopupPro #footer").height() -
          29
        );
        $("#barRight div:first-child").height(
          $("#uniPopupPro #results").height() - 20
        );
      } else {
        $("#uniPopupPro #results").height(
          $("#uniPopupPro").height() -
          $("#uniPopupPro #header").height() -
          $("#uniPopupPro #footer").height() -
          29
        );
        $("#barRight div:first-child").height(
          $("#uniPopupPro #results").height() - 70
        );
      }
      $(".fullScreen_popup").show();
      $(".restore_popup").hide();
    });
  // 插件最小化
  $("#uniPopupPro .minimality-popup")
    .unbind("click")
    .click(function () {
      // $("#uniPopupPro").css("left", "2900px");
      $(".maximize-popup").css("opacity", "1");
      $("#uniPopupPro").addClass("opacity0");
    });

  // 插件最大化
  $(".maximize-popup")
    .unbind("click")
    .click(function () {
      $(".maximize-popup").css("opacity", "0");
      $("#uniPopupPro").removeClass("opacity0");
    });

  // 复制id
  $("#asinCopy")
    .unbind("click")
    .click(function (e) { });

  $("#uniPopupPro #add-to-dashboard-check")
    .unbind("click")
    .click(function () {
      //保存当前关键词
      chrome.runtime.sendMessage({
        action: "toDashboard",
      });
    });
  $("#uniPopupPro .td-checkbox input")
    .unbind("click")
    .click(function () {
      //自定义选择数据展示
      var tdChecked = $("#uniPopupPro .td-checkbox input:checked")
        .parent("td")
        .parent("tr");
      $(this).parent("td").parent("tr").toggleClass("boxCheck");
      if (tdChecked.length > 0) {
        var vpriceSort = [],
          vrankSort = [],
          vsaleSort = [],
          vrevenueSort = [],
          vratingSort = [],
          vreviewSort = [];
        var priceTotal = 0,
          rankTotal = 0,
          salesTotal = 0,
          revenueTotal = 0,
          reviewsTotal = 0,
          ratingTotal = 0,
          currency = unicorn.amazon.currency,
          price = 0,
          rank = 0,
          sales = 0,
          reviews = 0,
          revenue = 0,
          rating = 0;
        $.each(tdChecked, function (index, row) {
          if ($(row).find(".td-price span").html()) {
            priceTotal += helper.toNumber(
              $(row)
                .find(".td-price span")
                .html()
                .replace(currency, "")
                .replace(/^\D+/, "")
            ); //获取price的总数
            vpriceSort.push(
              helper.toNumber(
                $(row)
                  .find(".td-price span")
                  .html()
                  .replace(currency, "")
                  .replace(/^\D+/, "")
              )
            );
          }
          if (helper.toNumber($(row).find(".td-salesrank").html())) {
            rankTotal += helper.toNumber($(row).find(".td-salesrank").html()); //获取rank的总数
            vrankSort.push(
              helper.toNumber($(row).find(".td-salesrank").html())
            );
          }
          if (unicorn.amazon.salesSupported) {
            if (
              helper.toNumber($(row).find(".td-sales").html().replace("<", ""))
            ) {
              salesTotal += helper.toNumber(
                $(row).find(".td-sales").html().replace("<", "")
              );
              vsaleSort.push(
                helper.toNumber(
                  $(row).find(".td-sales").html().replace("<", "")
                )
              );
            } //获取sales的总数
            if (
              helper.toNumber(
                $(row).find(".td-revenue").html().replace(currency, "")
              )
            ) {
              revenueTotal += helper.toNumber(
                $(row).find(".td-revenue").html().replace(currency, "")
              ); //获取revenue的总数
              vrevenueSort.push(
                helper.toNumber(
                  $(row).find(".td-revenue").html().replace(currency, "")
                )
              );
            }
          }

          if (helper.toNumber($(row).find(".td-reviews").html())) {
            reviewsTotal += helper.toNumber($(row).find(".td-reviews").html()); //获取sales的总数
            vreviewSort.push(
              helper.toNumber($(row).find(".td-reviews").html())
            );
          }
          if (helper.toNumber($(row).find(".td-rating").html())) {
            ratingTotal += helper.toNumber($(row).find(".td-rating").html()); //获取sales的总数
            vratingSort.push(helper.toNumber($(row).find(".td-rating").html()));
          }
        });
        var saleRating = "",
          widthTal = $(".star-rating").width() / 5,
          grade = "",
          reviewRating = "",
          saleRatingAverage = parseFloat(salesTotal / vsaleSort.length).toFixed(
            0
          ),
          reviewRatingAverage = parseFloat(
            reviewsTotal / vreviewSort.length
          ).toFixed(0);
        if (saleRatingAverage) {
          //销量得分
          if (saleRatingAverage < 100) {
            saleRating = 1;
          } else if (saleRatingAverage >= 100 && saleRatingAverage < 200) {
            saleRating = 2;
          } else if (saleRatingAverage >= 200 && saleRatingAverage < 600) {
            saleRating = 3;
          } else if (saleRatingAverage >= 600 && saleRatingAverage < 2000) {
            saleRating = 4;
          } else if (saleRatingAverage >= 2000) {
            saleRating = 5;
          }
        }
        if (reviewRatingAverage) {
          //评论得分
          if (reviewRatingAverage < 100) {
            reviewRating = 5;
          } else if (reviewRatingAverage >= 100 && reviewRatingAverage < 250) {
            reviewRating = 4;
          } else if (reviewRatingAverage >= 250 && reviewRatingAverage < 500) {
            reviewRating = 3;
          } else if (reviewRatingAverage >= 500 && reviewRatingAverage < 1000) {
            reviewRating = 2;
          } else if (reviewRatingAverage >= 1000) {
            reviewRating = 1;
          }
        }
        var gradeDetail = (saleRating + reviewRating) / 2;
        if (gradeDetail <= 2) {
          grade = "Low";
        } else if (gradeDetail > 3) {
          grade = "High";
        } else {
          grade = "Medium";
        }
        $(".star-rating-top").width(
          ((saleRating + reviewRating) / 2) * widthTal
        );
        $(".scored").html(grade);
        $(".star-rating")
          .addClass("has-tooltipPro")
          .attr("data-tooltipPro", (saleRating + reviewRating) / 2);
        if (vpriceSort.length > 0)
          price =
            currency + parseFloat(priceTotal / vpriceSort.length).toFixed(2);
        if (vrankSort.length > 0)
          rank = helper.numberWithCommas(
            parseFloat(rankTotal / vrankSort.length).toFixed(0)
          );
        if (vsaleSort.length > 0)
          sales = helper.numberWithCommas(
            parseFloat(salesTotal / vsaleSort.length).toFixed(0)
          );
        if (vrevenueSort.length > 0)
          revenue =
            currency +
            helper.numberWithCommas(
              parseFloat(revenueTotal / vrevenueSort.length).toFixed(0)
            );
        if (vreviewSort.length > 0)
          reviews = helper.numberWithCommas(
            parseFloat(reviewsTotal / vreviewSort.length).toFixed(0)
          );
        if (vratingSort.length > 0)
          rating = parseFloat(ratingTotal / vratingSort.length).toFixed(1);
        $("#priceSort>p").html(price);
        $("#rankSort>p").html(rank);
        $("#saleSort>p").html(sales);
        $("#revenueSort>p").html(revenue);
        $("#reviewSort>p").html(reviews);
        $("#ratingSort>p").html(rating);
      } else {
        unicorn.updateFooter();
      }
    });
  $("#uniPopupPro thead th").on("click", function () {
    $(".no-analyse,tr[class*=index-],analyse").remove();
    $(".bg-white").height($("#uniPopupPro #results tbody").height() + 20);
  });
  $("#head-container .head-fix th").on("click", function () {
    var index = $(this).index();
    $("#uniPopupPro #results-table .head-show th").eq(index).trigger("click");
  });

  // $("#results").on("scroll", function (e) {// 列表滚动监听
  //   e.preventDefault();
  //   e.stopPropagation();
  // if ($("#results").scrollTop() == 0) {
  //   $("#results-table .head-show").show();
  //   $(".transparent").show();
  //   $(".bg-white").css("top", "0px");
  //   //			$('#results').css('margin-top','0px');
  //   $("#head-container").hide();
  // } else {
  //   $("#head-container .head-fix").width($("#uniPopupPro").width());
  //   $("#results-table .head-show").hide();
  //   $(".transparent").hide();
  //   $(".bg-white").css("top", "0");
  //   $("#head-container").show();
  //   //			$('#results').css('margin-top','45px')
  // }
  // $("#uniPopupPro #results td.td-title").width(
  //   $("#uniPopupPro #head-container th.td-title").width()
  // );
  // if ($("#uniPopupPro #head-container").css("display") == "block")
  //   $("#uniPopupPro #results").height(
  //     $("#uniPopupPro").height() -
  //       $("#uniPopupPro #header").height() -
  //       $("#uniPopupPro #head-container").height() -
  //       $("#uniPopupPro #footer").height() -
  //       29
  //   );
  // else
  //   $("#uniPopupPro #results").height(
  //     $("#uniPopupPro").height() -
  //       $("#uniPopupPro #header").height() -
  //       $("#uniPopupPro #footer").height() -
  //       29
  //   );
  // var scroll = $("#results").scrollTop();
  // var scrollAll = $("#results table").height() - $("#results").height() + 18;
  // var listl = scroll / scrollAll;
  // var barScroll = $("#barRight").height() * listl;
  // if (barScroll >= $("#barRight").height())
  //   barScroll = $("#barRight").height() - 5;
  // if (barScroll <= 5) barScroll = -5;
  // $("#barDot").css("top", barScroll);
  // if ($("#results").scrollTop() > 0) $("#head-container").show();
  // else $("#head-container").hide();
  // });
  var left = 0;
  var top = 0;
  if ($("#barDot").offset()) {
    left = $("#barDot").offset().left;
    top = $("#barDot").offset().top;
  }

  $("#barDot").on("mousedown", function (e) {
    e.stopPropagation();
    e.preventDefault();
    document.onmousemove = function (e) {
      e.preventDefault();
      var barRightTop = $("#barRight").offset().top;
      var barRightBot = $("#barRight").offset().top + $("#barRight").height();
      var dotTop = e.pageY - barRightTop;
      var percent = dotTop / $("#barRight").height();
      var scrollAll = $("#results table").height() - $("#results").height();
      if (dotTop > $("#barRight").height())
        dotTop = $("#barRight").height() - 5;
      if (dotTop <= 5) dotTop = 0;
      $("#results").scrollTop(percent * scrollAll);
      if (percent * scrollAll > 0) $(".transparent").hide();
      else $(".transparent").show();
      $("#barDot").css("top", dotTop);
    };
  });
  document.onmouseup = function () {
    document.onmousemove = null;
  };

  var swithes = true;
  $("#uniPopupPro .variations-switch").on("click", function () {
    var pro = new UnicornProduct(document.URL);
    var tr = $(this).closest("tr"),
      index = $(tr).data("rank") - 1,
      variations = $(tr).data("variations");
    var variationStr = JSON.stringify(variations);
    //		$('.bg-white').height($("#uniPopupPro #results tbody").height()+20 + $('.analyse').height()+$('.no-analyse').height());
    if ($(this).hasClass("swithes")) {
      $(".index-" + index).hide();
      $(this).removeClass("swithes");
      $(tr).next(".analyse").remove();
      $(tr).next(".no-analyse").remove();
    } else {
      $(this).addClass("swithes");
      if (variationStr != "{}") {
        $(".index-" + index).show();
        pro.getVariationDetails(index, variations, $(tr));
        if ($(".index-" + index).length > 0) {
          $(tr).next(".analyse").remove();
        } else {
          $(tr).after(
            '<tr class="analyse"><td colspan="13" style="text-align: center;font-size:14px;font-weight: 600;">Analyzing...</td></tr>'
          );
        }
      } else {
        if ($(tr).next(".no-analyse").length <= 0) {
          $(tr).after(
            '<tr class="no-analyse"><td colspan="13" style="text-align: center;font-size:14px;font-weight: 600;">There are no additional variations for this product.</td></tr>'
          );
        }
      }
    }
    $(".bg-white").height($("#uniPopupPro #results tbody").height() + 20);
  });
}

// 导出excel
const exportExcel = (id) => {
  // 获取table的html内容了，里面包括标签的class或id等。
  const dom = document.getElementById(id).innerHTML;

  // 这样做是为了让excel表格的样式完整
  const excelHtml = ` ${dom}`;
  // 生成Excel
  const excelBlob = new Blob([excelHtml], {
    type: "application/vnd.ms-excel",
  });
  // 通过a标签下载到本地了，下载前可以利用a标签的download属性命名
  const downloadObj = document.createElement("a");
  // 兼容firefox
  const isFirefox = navigator.userAgent.toUpperCase().indexOf("FIREFOX") !== -1;
  if (isFirefox) {
    window.open(downloadObj, "_blank");
    return null;
  }
  // 利用URL.createObjectURL()方法为a元素生成blob URL
  downloadObj.href = URL.createObjectURL(excelBlob);
  // 给文件命名
  downloadObj.download = "comment.xls";
  downloadObj.click();
};

function sorta(a, b) {
  return a - b;
}
function getData() {
  if (unicorn.search.keywords == "") {
    var str1 = unicorn.search.url.indexOf("=");
    var str2 = unicorn.search.url.indexOf("&");
    var str = unicorn.search.url.substring(str1 + 1, str2);
    if (
      str1 === -1 &&
      str2 === -1 &&
      unicorn.search.url.indexOf("ref_") === -1
    ) {
      str = unicorn.search.url.split("/").pop();
    }
    unicorn.search.keywords = str;
  }
  $("#uniPopupPro #header #search-keywords").html(
    helper.decodeURI(unicorn.search.keywords)
  ); //插入keywords

  if (!unicorn.search.keywords) {
    //如果unicorn.search.keywords不存在
    $("#uniPopupPro #btn-add-to-dashboard")
      .addClass("uni-disabled")
      .attr("disabled", true); //禁止添加到dashboard
    $("#uniPopupPro #btn-add-to-dashboard-tooltipPro")
      .addClass("has-tooltipPro")
      .attr(
        "data-tooltipPro",
        "You can't add results to dashboard because it has no keywords"
      ); //添加提示
    $("#uniPopupPro #header #search-favorite").css("overflow", "unset"); //隐藏收藏按钮
  } else {
    //如果关键词存在
    $("#uniPopupPro #btn-add-to-dashboard-tooltipPro").remove(); //移除提示标签
    $("#uniPopupPro #btn-add-to-dashboard")
      .html("ADD TO DASHBOARD")
      .removeClass("uni-disabled")
      .removeAttr("disabled"); //允许添加到dashboard
    $("#uniPopupPro #header #search-favorite").css("visibility", "visible"); //显示灰色收藏按钮
  }
  if (unicorn.search.favorite)
    $("#uniPopupPro #header #search-favorite").addClass("fav");
  //是否收藏
  else $("#uniPopupPro #header #search-favorite").removeClass("fav");

  if (unicorn.search.activeAjaxCalls > 0) {
    //加载时展示
    $("#uniPopupPro #search-status").html("Analyzing...");
    $("#uniPopupPro #btn-add-to-dashboard").hide(); //ADD TO DASHBOARD按钮隐藏
    $("#uniPopupPro #add-to-dashboard-check").hide(); //ADD TO DASHBOARD成功后的状态隐藏
  } else {
    //加载完成后展示刷新按钮和添加按钮
    $("#uniPopupPro #search-status").html(
      helper.timestampToDate(unicorn.search.timestamp) +
      " (<span id='refresh-search'>Refresh</span>)"
    );
    $("#uniPopupPro #btn-add-to-dashboard").show();
  }

  let tbody = "";
  var pro = [];
  let products = null;
  var tbodyHtml = [];
  // if (document.URL.indexOf("/dp/") > -1) products = unicorn.search.multiPage;
  // else products = unicorn.search.products;
  products = unicorn.search.nowProducts;
  // console.log("所有数据2323213213213213213",unicorn)
  //循环unicorn.search.products的产品信息
  let brand = null;
  $.each(products, function (index, product) {
    brand = product.brand.replace(
      /(Visit the |Brand: |Store|Marke:|Marque :|Visiter la boutique|Visita la de|Visita la Store de|Marca:|Visita lo  di |Visita lo Store di )/gi,
      ""
    );
    let list = null;

    const keys = product.exhibition && Object.keys(product.exhibition);
    const list_item = document.getElementsByClassName("a-list-item");
    const zg_rankInfo = document.getElementsByClassName("zg-grid-general-faceout");
    const general_faceout = document.getElementsByClassName(
      "zg-carousel-general-faceout"
    );// 分类排行插入节点

    let fba_text = document.getElementsByClassName("fba_text");
    if (fba_text && fba_text[index]) {
      fba_text[index].innerText = "";
      fba_text[index].innerText = product.fba;
    }
    // embedCard-B09FQZFKJP-sponsored
    const noOutline = document.getElementsByClassName("s-no-outline");
    if (keys && keys.length >= 2 && !nextPageBool) {
      if (
        !noOutline.length &&
        list_item.length &&
        list_item[index] &&
        list_item[index].children.length < 2
      ) {
        list = list_item[index];
      }
      if (
        zg_rankInfo.length &&
        zg_rankInfo[index] &&
        zg_rankInfo[index].children.length < 2
      ) {
        list = zg_rankInfo[index];
        $(".a-ws div.a-column").css("height", "auto")

      }
      if (
        general_faceout.length &&
        general_faceout[index] &&
        general_faceout[index].children.length < 2
      ) {
        // console.log(general_faceout[index].children)
        for (let a = 0; a < general_faceout.length; a++) {
          if (
            general_faceout[a].innerHTML.indexOf(product.variantAsin) !== -1
          ) {
            list = general_faceout[a];
          }
        }
        // list = general_faceout[index];
        $("#anonCarousel1").css("height", "auto");
        $("#anonCarousel2").css("height", "auto");
        $("#anonCarousel3").css("height", "auto");
        $("#anonCarousel4").css("height", "auto");
        $("#anonCarousel5").css("height", "auto");
        $("#anonCarousel6").css("height", "auto");
        $("#anonCarousel7").css("height", "auto");
      }
      if (noOutline.length) {
        searchExhibition(product, product.asin);
      }
      // console.log(product)
      // console.log(list&&list.children.length)
      list && list.append(product.exhibition.DIV);
    }
    if (product.variantAsin) {
      const Historical_Date =
        document.getElementsByClassName("Historical_Date");
      let productInfo = {
        category_rank: product.SeeTop,
        amazon_choice: product.amazon_choice || "",
        sellers_number: product.seller || "",
        name: product.title, // 产品标题
        asin: product.variantAsin,
        parent_asin: product.parentAsin, // 父asin
        domain: product.domain, // 站点域名
        url: product.canonical, // 产品链接
        category: product.category, // 产品分类
        daily_sales: product.daily_sales, // 日销量
        monthly_sales: product.sales, // 月销量
        discount: product.Coupon ? product.Coupon.replace(/<.*?>/gi, "") : "",
        sales_rank: product.rank, // 销量排名
        image: product.image, // 产品主图
        review_number: product.reviews, // 评论数量
        review_star: product.rating, // 产品星级
        shipping: product.fba, // 发货方式
        price: product.price, // 价格
        created_at: "", //
        updated_at: "",
        features: product.features, // 描述，特点
        first_available: product.date, // 初次上架时间
        weight: product.weight ? product.weight.replace(/\n/g, "") : "", // 产品重量
        brand: brand, // 品牌
        is_adult: product.is_adult || 0, // 是否成人用品
        keywords:
          unicorn.search.keywords.indexOf("https:") === -1
            ? unicorn.search.keywords
            : "",
      };
      if (Historical_Date && Historical_Date[index]) {
        // console.dir(Historical_Date[index])
      }
      const updateFun = updateProduct(
        productInfo,
        product.variantAsin || product.parent_asin
      );
      updateFun({
        url: `${unicorn.amazon.URL[unicorn.amazon.env]}storage/add`,
        method: "POST",
        success: (res) => {
          // updateProductArr.length = 0;
          // console.log(res);
        },
        error: (err) => {
          // updateProductArr.length = 0;
          // console.log(err);
        },
      });
    }

    var fbaTitle = "Fulfilled by merchant"; //给变量赋值
    if (product.fba == "FBA") fbaTitle = "Fulfilled by Amazon";
    if (product.fba == "AMZ") fbaTitle = "Sold by Amazon";

    // if (!product.title) return;//----------------------------------------------
    //编写插入字符串
    var variation = JSON.stringify(product.variations);
    var tr =
      "<tr id='product_" +
      product.rank +
      "' data-variations = '" +
      variation
      + "' data-rank='" +
      product.rank +
      "' data-image='" +
      product.image +
      "'>";
    tr +=
      '<td class="td-checkbox" style="width:41px"><input type="checkbox" name="dig-checkbox" id="dig-' +
      product.rank +
      '"/><label for="dig-' +
      product.rank +
      '"></label></td><td class="td-rank">' +
      product.rank +
      "</td>";
    tr +=
      '<td class="td-image" style=""width:86px><img height="45" src="' +
      product.image +
      '" data=image="' +
      product.image +
      '"/></td>';

    if (product.sponsored)
      tr +=
        '<td class="td-title"><div class = "variations-switch has-tooltipPro" data-tooltipPro="Check variations sales">+</div><div class="ellipsis"><span class = "td-sponsored has-tooltipPro" data-tooltipPro="Sponsored product">' +
        product.sponsored +
        '</span><a class="has-tooltipPro" data-tooltipPro="' +
        product.title +
        "<hr>" +
        product.canonicalShort +
        '" target="_blank" href="' +
        product.url +
        '">' +
        product.title +
        "</a></div></td>";
    else
      tr +=
        '<td class="td-title"><div class = "variations-switch has-tooltipPro" data-tooltipPro="Check variations sales">+</div><div class="ellipsis"><a class="has-tooltipPro" data-tooltipPro="' +
        product.title +
        "<hr>" +
        product.canonicalShort +
        '" target="_blank" href="' +
        product.url +
        '">' +
        product.title +
        "</a></div></td>";

    tr +=
      '<td class="td-link">http://' +
      product.domain +
      "/" +
      product.canonicalShort +
      "/dp/" +
      product.asin +
      "</td>";
    tr +=
      '<td class="td-brand has-tooltipPro" data-tooltipPro="' +
      brand +
      '"><div class="ellipsis"><a href="' +
      product.brandUrl +
      '" target="_blank" style="color: rgb(50, 46, 98);">' +
      brand +
      "</a></div></td>";
    tr +=
      '<td class="td-sellers" style="diaplay:none;">' +
      product.sellersNew +
      "</td>";

    // tr +=
    //   '<td class="td-Dsellers" style="diaplay:none;">' +
    //   product.sellersNew +
    //   "</td>";

    //  if (product.asins.length < 1) tr += '<td class="td-variations">1</td>';
    //  else tr += '<td class="td-variations">' + product.asins.length + '</td>';
    if (helper.isNum(product.price)) {
      tr +=
        '<td class="td-price"><span>' +
        product.currency +
        product.price +
        '</span><a href="https://www.alibaba.com/trade/search?fsb=y&IndexArea=product_en&CatId=&SearchText=' +
        unicorn.search.keywords +
        '" target="_blank" class = "share-img has-tooltipPro" data-tooltipPro="Check similar product cost on Alibaba.com"></a></td>';
    } else tr += '<td class="td-price">-<a href="https://www.alibaba.com/trade/search?fsb=y&IndexArea=product_en&CatId=&SearchText=' + unicorn.search.keywords + '" target="_blank" class = "share-img has-tooltipPro" data-tooltipPro="Check similar product cost on Alibaba.com"></a></td>';

    if (product.Coupon) {
      // console.log(product.Coupon)
      tr += `<td class="td-Coupon">${product.Coupon.replace(
        /<.*?>/gi,
        ""
      )}</td>`;
    } else {
      tr += `<td class="td-Coupon">-</td>`;
    }
    if (product.category)
      tr +=
        '<td class="td-category has-tooltipPro" data-tooltipPro="' +
        product.category +
        '"><div class="ellipsis">' +
        product.category +
        "<div></td>";
    else
      tr +=
        '<td class="td-category"><div class = "has-tooltipPro" data-tooltipPro="No parent category in this listing.">-</div></td>';

    if (product.salesRank == "" || product.salesRank == "-")
      tr +=
        '<td class="td-salesrank has-tooltipPro" data-tooltipPro="Amazon doesn’t rank this product in the parent category.">-</td>';
    else tr += '<td class="td-salesrank">' + product.salesRank + "</td>";
    if ($.isNumeric(product.daily_sales)) {
      tr +=
        '<td class="td-sales">' +
        helper.numberWithCommas(product.daily_sales) +
        "</td>";
    } else {
      tr += '<td class="td-sales"> - </td>';
    }
    if (amazon(window.location.hostname).salesSupported) {
      if ($.isNumeric(product.sales)) {
        if (helper.toNumber(product.sales) <= 5)
          tr += '<td class="td-sales">< 5</td>';
        else
          tr +=
            '<td class="td-sales">' +
            helper.numberWithCommas(product.sales) +
            "</td>";
      } else
        tr +=
          '<td class="td-sales has-tooltipPro" data-tooltipPro="Monthly sales can’t be estimated without its rank in the parent category.">-</td>';

      if ($.isNumeric(product.revenue)) {
        if (helper.toNumber(product.sales) <= 5)
          tr +=
            '<td class="td-revenue">' +
            product.currency +
            helper.numberWithCommas(
              Math.round(helper.toNumber(product.price) * 5)
            ) +
            "</td>";
        else
          tr +=
            '<td class="td-revenue">' +
            product.currency +
            helper.numberWithCommas(product.revenue) +
            "</td>";
      } else
        tr +=
          '<td class="td-revenue has-tooltipPro" data-tooltipPro="Monthly revenue can’t be estimated without its rank in the parent category.">-</td>';
    } else {
      tr += '<td class="td-sales" colspan="2">Coming Soon</td>';
    }
    if (product.reviews)
      tr +=
        '<td class="td-reviews_"><a target="_blank" class="td-reviews" style="color: rgb(3, 0, 0);" href=' +
        product.url +
        "#reviewsMedley>" +
        product.reviews +
        "</a></td>";
    else tr += '<td class="td-reviews td-reviews_">-</td>';
    if (
      $.isNumeric(product.moReviews) &&
      $.isNumeric(helper.toNumber(product.sales))
    ) {
      let score = null;
      if (helper.toNumber(product.sales) && product.moReviews) {
        score = (
          (product.moReviews / helper.toNumber(product.sales)) *
          100
        ).toFixed(0);
      } else {
        score = "-";
      }
      tr += `<td class="td-Leave_review">${!isNaN(score) ? (score != 0 ? score : "1") : 0
        }%</td>`;
    } else {
      tr += `<td class="td-Leave_review"> - </td>`;
    }
    if (product.rating) tr += `<td class="td-rating">${product.rating}</td>`;
    else tr += '<td class="td-rating td-rating_">-</td>';

    tr +=
      '<td class="td-fba has-tooltipPro" data-tooltipPro="' +
      fbaTitle +
      '"><div>' +
      product.fba +
      "</div></td>";
    if (product.date)
      tr +=
        '<td class="td-list has-tooltipPro" data-tooltipPro="Date first listed on Amazon"><div>' +
        product.date +
        "</div></td>";
    else tr += '<td class="td-list"><div>---</div></td>';
    tbody += tr;

    // let mo_Sales = document.getElementsByClassName("mo_Sales");
    // let d_Sales = document.getElementsByClassName("d_Sales");
    // let mo_Revenue = document.getElementsByClassName("mo_Revenue");

    if (keys && keys.length >= 2 && !noOutline.length && !nextPageBool) {
      setTimeout(() => {
        SalesCallback(product, document, index);
      }, 300);
    }
    // var timer = setTimeout(function () {
    //定时器，每隔50ms执行一次
    if (!pro[index]) {
      pro[index] = 0;
    }
    pro[index] += 50;
    if (product.category != "" || pro[index] > 30000) {
      //如果产品分类存在或者pro[index]>30000
      $("#product_" + product.rank + " .td-category .ellipsis").html(
        product.category
      ); //把每个产品的category的值赋值给$('#product_'+product.rank+' .td-category .ellipsis')
      $("#product_" + product.rank + " .td-category").attr(
        "data-tooltipPro",
        product.category
      ); //给$('#product_'+product.rank+' .td-category .ellipsis')增加data-tooltipPro属性
      // clearInterval(timer); //清除定时器
    }
    // }, 50);
  });

  if (!$("#uniPopupPro").length) {
    $("body").append('<div id="uniPopupPro" class="ui-widget-content"></div>');
    $("#uniPopupPro").html(unicorn.popupTemplate);
    var resultTable = $("#uniPopupPro #results-table").width();
    $("#uniPopupPro").resizable({
      handles: "n, e, s, w , ne, se, sw, nw",
      minHeight: 650,
      minWidth: 1090,
      maxHeight: 920,
      resize: function (event, ui) {
        //Change the height of the menu
        if ($("#results").scrollTop() > 0) {
          $("#uniPopupPro #results").height(
            $("#uniPopupPro").height() -
            $("#uniPopupPro #header").height() -
            $("#uniPopupPro #head-container").height() -
            $("#uniPopupPro #footer").height() -
            29
          );
          $("#barRight div:first-child").height(
            $("#uniPopupPro #results").height() - 20
          );
        } else {
          $("#uniPopupPro #results").height(
            $("#uniPopupPro").height() -
            $("#uniPopupPro #header").height() -
            $("#uniPopupPro #footer").height() -
            29
          );
          $("#barRight div:first-child").height(
            $("#uniPopupPro #results").height() - 70
          );
        }
      },
    });
    $("#uniPopupPro").draggable({});
    $("#results-table").tablesorter({
      //设置第三方表格排序
      headers: {
        1: {
          sorter: "numberWithCommas",
        },

        5: {
          sorter: "numberWithCommas",
        },
        7: {
          sorter: "numberWithCommas",
        },
        8: {
          sorter: "numberWithCommas",
        },
        9: {
          sorter: "numberWithCommas",
        },
        10: {
          sorter: "numberWithCommas",
        },
        11: {
          sorter: "numberWithCommas",
        },

        13: {
          sorter: "numberWithCommas",
        },
      },
    });
    // console.log(unicorn)
    $("#uniPopupPro #results-table tbody").html(tbody); //插入字符串
    if (document.URL.indexOf("/dp/") > -1) $("#btn-next-page").remove(); //如果是详情页，隐藏下一页的点击按钮
    $("#uniPopupPro #results-table").trigger("update"); //触发数据更新
  } else {
    $("#uniPopupPro #results-table tbody").html(tbody);
    $("#uniPopupPro #results-table").trigger("update");
  }

  if (tbody == "") {
    $("#uniPopupPro #message").show();
    $("#results-table thead").hide();
    $("#head-container").show();
    $(".transparent").hide();
    $(".bg-white").css("top", "0px");
  } //如果没有抓取产品数据，则$('#uniPopupPro #message')出现
  else {
    $("#uniPopupPro #message").hide();
    $("#results-table thead,.transparent").show();
    // $("#head-container").hide();
    $(".bg-white").css("top", "0px");
    if ($("#uniPopupPro #results").scrollTop() > 0) $("#head-container").show();
    // else $("#head-container").hide();
  } //如果有抓取产品数据，则$('#uniPopupPro #message')隐藏
  if ($("#uniPopupPro #head-container").css("display") == "block")
    $("#uniPopupPro #results").height(
      $("#uniPopupPro").height() -
      $("#uniPopupPro #header").height() -
      $("#uniPopupPro #head-container").height() -
      $("#uniPopupPro #footer").height() -
      29
    );
  else
    $("#uniPopupPro #results").height(
      $("#uniPopupPro").height() -
      $("#uniPopupPro #header").height() -
      $("#uniPopupPro #footer").height() -
      29
    );
  if ($("#uniPopupPro #results-table tbody").height() < 425)
    $(".bg-white").height(425);
  else
    $(".bg-white").height($("#uniPopupPro #results-table tbody").height() + 20);
  unicorn.updateFooter(); //更新底部
  uniSetEvents();
}

function searchExhibition(info, id) {
  const DIV = document.createElement("div");
  DIV.className = "exhibition";
  // searchList
  let children = null;
  const searchMain = $(`span[data-component-type="s-search-results"]`);
  let searchChildren = searchMain[0].querySelectorAll("[data-asin]");
  const JungleSponsored = document.getElementById(`embedCard-${id}-sponsored`);
  const JungleRegular = document.getElementById(`embedCard-${id}-regular`);
  if (JungleSponsored) {
    if (
      JungleSponsored.parentElement.getElementsByClassName("exhibition").length
    )
      return;

    DIV.innerHTML = info.exhibition.str;
    $(DIV).insertAfter(
      JungleSponsored.parentElement.children[
      JungleSponsored.parentElement.children.length - 2
      ]
    );
    return;
  }

  if (JungleRegular) {
    if (JungleRegular.parentElement.getElementsByClassName("exhibition").length)
      return;

    DIV.innerHTML = info.exhibition.str;
    $(DIV).insertAfter(
      JungleRegular.parentElement.children[
      JungleRegular.parentElement.children.length - 2
      ]
    );
    // $(DIV).insertAfter(JungleRegular.parentElement.children[0]);
    return;
  }
  for (let a = 0; a < searchChildren.length; a++) {
    const DIV = document.createElement("div");
    DIV.className = "exhibition marginTB";
    if (searchChildren[a].dataset.asin && searchChildren[a].dataset.uuid) {
      if (id && searchChildren[a].dataset.asin == id) {
        DIV.innerHTML = info.exhibition.str;
        // console.log(id,searchChildren[a].dataset.asin)
        // children = info.DIV;
        if (searchChildren[a].children.length < 2) {
          searchChildren[a].append(DIV);
          searchChildren[a].append(DIV);
        } else {
          SalesCallback(info, searchChildren[a]);
        }
      }
    }
  }
  info.exhibition = null;
}
function SalesCallback(product, node, index = 0) {
  let mo_Sales = node.getElementsByClassName("mo_Sales");
  let d_Sales = node.getElementsByClassName("d_Sales");
  let mo_Revenue = node.getElementsByClassName("mo_Revenue");
  if (!mo_Sales[index] || !d_Sales[index]) return;
  mo_Sales[index].innerHTML = `Mo. Sales：${product.sales || "-"}`;
  d_Sales[index].innerHTML = `D. Sales：${product.daily_sales || "-"}`;
  if (helper.toNumber(product.sales) <= 5) {
    mo_Revenue[index].innerHTML = `Mo. Revenue :${product.currency +
      helper.numberWithCommas(Math.round(helper.toNumber(product.price) * 5))
      }`;
  } else {
    mo_Revenue[index].innerHTML = `Mo. Revenue :${product.currency + helper.numberWithCommas(product.revenue)
      }`;
  }
}
// console.dir(searchList[0]);
function unicornRender() {
  // console.log("数据123213123",unicorn)
  if (unicorn.search.nowProducts.length > 0) {
    localforage.setItem('product' + unicorn.search.domain + unicorn.search.pageNext, JSON.stringify(unicorn.search.nowProducts)).then(val => {
      // console.log('存储成功')
    }).catch(err => { console.log("存储错误") })
    // sessionStorage.setItem('product'+unicorn.search.domain+unicorn.search.pageNext,JSON.stringify(unicorn.search.nowProducts))
  }
  var tbody = "";
  $.ajax({
    url: `${unicorn.amazon.URL[unicorn.amazon.env]}token/check`,
    method: "POST",
    cache: false,
    "Content-Type": "application/json",
    data: {
      token: signToken,
    },
    error: function (err) {
      // console.log(err);
      if (err.status == 401) {
        signToken = null;
        localStorage.setExpire("signToken", null);
        for (let index = 0; index < 1000; index++) {
          if (localforage.getItem('product' + unicorn.search.domain + index)) {
            localforage.removeItem('product' + unicorn.search.domain + index);
          }
        }
        return;
      }
    },
    complete: function () { },
  });
  if (signToken != null) {
    getData();
    $("#mask").hide();
  } else {
    if ($("#mask").css('display') == 'none') {
      $("#mask").show();
    }
    if (!$("#uniPopupPro").length) {
      $("body").append(
        '<div id="uniPopupPro" class="ui-widget-content"></div>'
      );

      $("#uniPopupPro").html(unicorn.popupTemplate);
      var resultTable = $("#uniPopupPro #results-table").width();
      $("#uniPopupPro").draggable({});

      // $("#uniPopupPro").resizable({
      //   handles: "n, e, s, w , ne, se, sw, nw",
      //   minHeight: 650,
      //   minWidth: 1090,
      //   maxHeight: 920,
      //   resize: function (event, ui) {
      //     //Change the height of the menu
      //     if ($("#results").scrollTop() > 0) {
      //       $("#uniPopupPro #results").height(
      //         $("#uniPopupPro").height() -
      //           $("#uniPopupPro #header").height() -
      //           $("#uniPopupPro #head-container").height() -
      //           $("#uniPopupPro #footer").height() -
      //           29
      //       );
      //       $("#barRight div:first-child").height(
      //         $("#uniPopupPro #results").height() - 20
      //       );
      //     } else {
      //       $("#uniPopupPro #results").height(
      //         $("#uniPopupPro").height() -
      //           $("#uniPopupPro #header").height() -
      //           $("#uniPopupPro #footer").height() -
      //           29
      //       );
      //       $("#barRight div:first-child").height(
      //         $("#uniPopupPro #results").height() - 70
      //       );
      //     }
      //   },
      // });
      // console.log("拖拽");

      // $("#results-table").tablesorter({
      //   //设置第三方表格排序
      //   headers: {
      //     1: {
      //       sorter: "numberWithCommas",
      //     },

      //     5: {
      //       sorter: "numberWithCommas",
      //     },
      //     7: {
      //       sorter: "numberWithCommas",
      //     },
      //     8: {
      //       sorter: "numberWithCommas",
      //     },
      //     9: {
      //       sorter: "numberWithCommas",
      //     },
      //     10: {
      //       sorter: "numberWithCommas",
      //     },
      //     11: {
      //       sorter: "numberWithCommas",
      //     },

      //     13: {
      //       sorter: "numberWithCommas",
      //     },
      //   },
      // });
      $("#uniPopupPro #results-table tbody").html(tbody); //插入字符串
      if (document.URL.indexOf("/dp/") > -1) $("#btn-next-page").remove(); //如果是详情页，隐藏下一页的点击按钮
      $("#uniPopupPro #results-table").trigger("update"); //触发数据更新
    } else {
      $("#uniPopupPro #results-table tbody").html(tbody);
      $("#uniPopupPro #results-table").trigger("update");
    }

    if (tbody == "") {
      $("#uniPopupPro #message").show();
      $("#results-table thead").hide();
      $("#head-container").show();
      $(".transparent").hide();
      $(".bg-white").css("top", "0px");
    } //如果没有抓取产品数据，则$('#uniPopupPro #message')出现
    else {
      $("#uniPopupPro #message").hide();
      $("#results-table thead,.transparent").show();
      // $("#head-container").hide();
      $(".bg-white").css("top", "0px");
      if ($("#uniPopupPro #results").scrollTop() > 0)
        $("#head-container").show();
      // else $("#head-container").hide();
    } //如果有抓取产品数据，则$('#uniPopupPro #message')隐藏
    if ($("#uniPopupPro #head-container").css("display") == "block")
      $("#uniPopupPro #results").height(
        $("#uniPopupPro").height() -
        $("#uniPopupPro #header").height() -
        $("#uniPopupPro #head-container").height() -
        $("#uniPopupPro #footer").height() -
        29
      );
    else
      $("#uniPopupPro #results").height(
        $("#uniPopupPro").height() -
        $("#uniPopupPro #header").height() -
        $("#uniPopupPro #footer").height() -
        29
      );
    if ($("#uniPopupPro #results-table tbody").height() < 425)
      $(".bg-white").height(425);
    else
      $(".bg-white").height(
        $("#uniPopupPro #results-table tbody").height() + 20
      );
    unicorn.updateFooter(); //更新底部

    uniSetEvents();
  }
}
function showtooltipPro(el) {
  //展示提示

  var top = el.offset().top,
    uniLeft = $("#uniPopupPro").offset().left;
  var left = el.offset().left;
  var tooltipPro = el.attr("data-tooltipPro");

  if (tooltipPro == "") return;

  $("#uniPopupPro #tooltipPro").html(tooltipPro);

  var width = $("#uniPopupPro #tooltipPro").width(),
    uniWidth = $("#uniPopupPro").width(),
    elWidth = el.width();
  var height = $("#uniPopupPro #tooltipPro").height();

  if (uniLeft + uniWidth - left < width) left = left - width + elWidth;
  top = top - height - 8;

  $("#uniPopupPro #tooltipPro")
    .offset({
      top: top,
      left: left,
    })
    .html(tooltipPro)
    .show();
}

const advertisingAjax = () => {
  // console.log(unicorn, "advertisingAjax");

  $.ajax({
    url: `${unicorn.amazon.URL[unicorn.amazon.env]}diversion/get`, //  https://unicornsmasherpro.com/api/keyword/addKeyword
    method: "GET",
    cache: false,
    error: function (jqXHR, textStatus, errorThrown) {
      //by ouyang
      //console.log(jqXHR, textStatus, errorThrown)
    },
    success: function ({ data, code }) {
      if (code === 200) {
        data.messages.forEach((item) => {
          const li = `<li ><a href="${item.redirect_url}"style="color: #FF8200;" target="_blank">${item.message}</a></li>`;
          $("#unicorn_advertising ._advertising").append(li);
        });
        $("unicorn_advertising").show();
        times = setInterval(() => {
          autoScroll(data.messages);
          addEvent();
        }, 5000);
      }
      //console.log(data)
    },
  });
};
// window.setInterval(() => {
//   signToken = localStorage.getExpire("signToken");
// }, 1000);
function autoScroll(obj) {
  let num = 0;
  let count = 0;
  let scrollMove = null;
  let advertising = document.getElementById("unicorn_advertising");
  let box = document.getElementById("unicorn_scroll");
  // let box = document.getElementById("unicorn_scroll");
  let l1 = document.getElementsByClassName("_advertising")[0];
  let l2 = document.getElementsByClassName("_advertising2")[0];
  if (l1 && l2) {
    l2.innerHTML = l1.innerHTML; //克隆list1的数据，使得list2和list1的数据一样
  }
  function scrollup() {
    count++;
    if (box && l1) {
      if (box.scrollTop >= l1.offsetHeight) {
        //滚动条距离顶部的值恰好等于list1的高度时，达到滚动临界点，此时将让scrollTop=0,让list1回到初始位置，实现无缝滚动
        num += box.scrollTop;
        box.style.top = 0;
      } else {
        box.scrollTop++;
        num++;
      }
    }
    // if (count <= obj.length - 1) {
    //   if (num >= l1.scrollHeight - 10) {
    //     clearInterval(scrollMove);
    //   }
    //   count = 0;
    // } else {
    if (num >= 26) {
      clearInterval(scrollMove);
    }
    // }
  }

  scrollMove = setInterval(scrollup, 50); //数值越大，滚动速度越慢
}

function addEvent() {
  if (document.getElementById("unicorn_advertising")) {
    document
      .getElementById("unicorn_advertising")
      .addEventListener("mouseover", () => {
        clearInterval(times);
      });
    document
      .getElementById("unicorn_advertising")
      .addEventListener("mouseout", () => {
        clearInterval(times);
        times = setInterval('autoScroll("#unicorn_advertising")', 5000);
      });
  }
}
//存储token
Storage.prototype.setExpire = (key, value, expire) => {
  let obj = {
    data: value,
    time: Date.now(),
    expire: expire,
  };
  localStorage.setItem(key, JSON.stringify(obj));
};
Storage.prototype.getExpire = (key) => {
  let val = localStorage.getItem(key);
  if (!val) {
    return val;
  }
  val = JSON.parse(val);
  if (Date.now() - val.time > val.expire) {
    localStorage.removeItem(key);
    return null;
  }
  return val.data;
};

setTimeout(() => {
  if (
    document.URL.indexOf("amazon") !== -1 &&
    (document.URL.indexOf("s?k=") !== -1 ||
      document.URL.indexOf("gp/bestsellers") !== -1 ||
      document.URL.indexOf("Best-Sellers") !== -1)
  ) {
    (function () {
      signToken = localStorage.getExpire("signToken");
      // console.log($.cookie('mycookie'))

      if (list) {
        if (!unicorn) {
          unicorn = new UnicornPopup(); //新创建UnicornPopup方法
        } else if (unicorn.search.url !== document.URL) {
          if (document.URL.indexOf("/dp/") > -1)
            unicorn.search.scrapeProducts("refresh");
          else unicorn.search.scrapeProducts("refresh"); //刷新重新抓取数据
          unicornRender(); //数据渲染
        }
        $("#uniPopupPro").show(); //unicorn smasher弹出框弹出
        // if (request.data && request.data.analyticsPrompt) {
        //首次使用时
        // unicorn.showAnalyticsPrompt(); //首次安装出现提示框
        // }
      } else {
        $("#uniPopupPro").css("display", "none");
      }
      // list = !list;
      $(".unicorn_advertising").hide();
      // $("#uniPopupPro").css("display", "none");

      advertisingAjax();
      saveKeyword(unicorn.search.keywords, unicorn.search.domain);
    })();
    setTimeout(() => {
      $.get(chrome.runtime.getURL("/message.html"), function (data) {
        $("body").append($.parseHTML(data));
      });
    });
  } else {
    NOSHOW = false;
  }
}, 500);

const checkTokenCallback = (Callback) => {
  // console.log(unicorn, "checkTokenCallback");

  $.ajax({
    url: `${unicorn.amazon.URL[unicorn.amazon.env]}token/check`,
    method: "POST",
    cache: false,
    "Content-Type": "application/json",
    data: {
      token: signToken,
    },
    success: (res) => {
      // console.log(res);
      Callback();
    },
    error: function (err) {
      console.log(err);
      if (err.status == 401) {
        signToken = null;
        localStorage.setExpire("signToken", null);
        $("#unicorn_message").addClass("unicorn_message_tips");

        // Callback(false);
        return;
      }
    },
  });
};

const commentEvents = () => {
  $("body")
    .off()
    .on("click", ({ target: { className, id: node_id, dataset } }) => {
      if (node_id === "uniPopupPro") {
        $("#uniPopupPro").draggable({});
      }
      if (node_id === "onGetComments") {
        if (sessionStorage.getItem("onGetComments")) return;
        $(".unicorn_progress").css(`visibility`, `hidden`);
        $(".percent").text(`0%`);
        $(".progress").css(`width`, `0%`);
        sessionStorage.setItem("onGetComments", "true");
        sessionStorage.removeItem("unicorn_close");
        checkTokenCallback(() => {
          $(".table_description").hide();
          $(".table_more").addClass("uniHide");
          $(".loding_more").removeClass("uniHide");
          $("#unicorn_modal").css("display", "flex");
          $("#unicorn_modal tbody").empty();
          const pro = new UnicornProduct(document.URL);
          const ID = dataset.asin;

          // $("#uniPopupPro").draggable({ disabled: true });
          commentsMap[ID] = {
            page: 1,
            id: ID,
            Verified: "all_reviews",
            keywords: "",
            sort: "helpful",
            star: "all_stars",
          };

          // $(".review_rating").text("");
          id = dataset.asin;
          setTimeout(() => {
            pro.getComments(commentsMap[ID]);
          }, 0);
        });
      }
      if (node_id === "Historical_Date") {
        $(".uni_Historical_data").show();
        echartsCallback("UniChart", {
          title: {
            text: "",
          },
          tooltip: {},
          legend: {
            data: ["销量"],
          },
          xAxis: {
            data: ["衬衫", "羊毛衫", "雪纺衫", "裤子", "高跟鞋", "袜子"],
          },
          yAxis: {},
          series: [
            {
              name: "销量",
              type: "bar",
              data: [5, 20, 36, 10, 10, 20],
              barWidth: "10%",
              itemStyle: {
                // normal:{
                barBorderRadius: [6, 6, 0, 0],
                // },
                color: {
                  type: "linear",
                  x: 0,
                  y: 0,
                  x2: 0,
                  y2: 1,
                  colorStops: [
                    {
                      offset: 0,
                      color: "#9127FD", // 0% 处的颜色
                    },
                    {
                      offset: 1,
                      color: "#DD20FA", // 100% 处的颜色
                    },
                  ],
                  global: false, // 缺省为 false
                },
              },
            },
          ],
        });
      }
      if (node_id === "asinCopy") {
        console.log("复制");
        const ID = dataset.asin;
        copyText(
          ID,
          (res) => {
            console.log(res);
            $(`.copy_success-${dataset.asin}`).css("opacity", "1");
          },
          (err) => {
            console.log(err);
          }
        );
      }
    });
  $("#unicorn_message")
    .off()
    .on("click", () => {
      $("#unicorn_message").removeClass("unicorn_message_tips");
      $("#uniPopupPro").show();
      $("#uniPopupPro").removeClass("opacity0");
      // $("#mask").show();
    });
  // 加载更多
  $("#unicorn_modal .table_more")
    .unbind("click")
    .click((e) => {
      console.log("加载更多");
      if (sessionStorage.getItem("loading")) return;

      $(".loding_more").removeClass("uniHide");
      $(".table_more").addClass("uniHide");
      let pro = new UnicornProduct(document.URL);
      if (pages) {
        commentsMap[id].page = pages;
      }
      // commentsMap[id].page++;
      setTimeout(() => {
        pro.getComments(commentsMap[id], "click");
      }, 100);
    });

  // 筛选
  $("#unicorn_modal .filter_Search")
    .unbind("click")
    .click((e) => {
      e.stopPropagation();
      if (sessionStorage.getItem("loading")) return;

      $("#unicorn_modal tbody").empty();
      $(".table_more").addClass("uniHide");
      $(".loding_more").removeClass("uniHide");
      let Verified = $("#Verified_select").text();
      let keywords = $(".input_keywords").val();
      let pro = new UnicornProduct(document.URL);
      commentsMap[id].page = 1;
      commentsMap[id].keywords = keywords.trim();
      $(".table_description").hide();
      $(".star_selection").css("display", "none");
      setTimeout(() => {
        pro.getComments(commentsMap[id]);
      });
    });

  // 关闭评论框
  $("#unicorn_modal .unicorn_close")
    .unbind("click")
    .on("click", function () {
      $("#unicorn_modal").css("display", "none");
      sessionStorage.setItem("unicorn_close", "true");
      sessionStorage.removeItem("loading");
      sessionStorage.removeItem("unicorn_Dowbload");

      pages = null;
      const obj = {
        Verified: "all_reviews",
        keywords: "",
        sort: "helpful",
        star: "all_stars",
      };
      $(".filter_Keywords input").val("");

      $(".Verified_select").text("All");
      $(".Star_select").text("All");
      $(".sort_select").text("All");
      for (const k in obj) {
        commentsMap[id][k] = obj[k];
      }
    });

  // 选择下拉框
  $("#unicorn_modal #star_selection")
    .unbind("click")
    .on("click", "li", function () {
      if (sessionStorage.getItem("loading")) return;

      $("#Star_select").text($(this).text());
      $(".star_check").css("display", "none");
      commentsMap[id].star = $(this).data("star");
      $("#unicorn_modal .filter_Search").click();
    });
  $("#unicorn_modal #Verified_selection")
    .unbind("click")
    .on("click", "li", function () {
      if (sessionStorage.getItem("loading")) return;

      $("#Verified_select").text($(this).text());
      $(".Verified_check").css("display", "none");
      commentsMap[id].Verified = $(this).data("verified");
      $("#unicorn_modal .filter_Search").click();
    });
  $("#unicorn_modal #sort_selection")
    .unbind("click")
    .on("click", "li", function () {
      if (sessionStorage.getItem("loading")) return;

      $("#sort_select").text($(this).text());
      $(".sort_check").css("display", "none");
      commentsMap[id].sort = $(this).data("sort");
      $("#unicorn_modal .filter_Search").click();
    });

  // 下拉框显示
  $("#unicorn_modal #Star_select")
    .unbind("click")
    .click((e) => {
      if (sessionStorage.getItem("loading")) return;

      $(".star_selection").css("display", "none");
      $(".star_check").css("display", "block");
      e.stopPropagation();
    });

  $("#unicorn_modal #Verified_select")
    .unbind("click")
    .click((e) => {
      if (sessionStorage.getItem("loading")) return;

      $(".star_selection").css("display", "none");
      $(".Verified_check").css("display", "block");
      e.stopPropagation();
    });

  $("#unicorn_modal #sort_select")
    .unbind("click")
    .click((e) => {
      if (sessionStorage.getItem("loading")) return;

      $(".star_selection").css("display", "none");
      $(".sort_check").css("display", "block");
      e.stopPropagation();
    });
  $("#unicorn_modal .unicorn_Dowbload")
    .unbind("click")
    .click(() => {
      if (sessionStorage.getItem("loading")) return;
      if (sessionStorage.getItem("unicorn_Dowbload")) return;
      sessionStorage.setItem("unicorn_Dowbload", "true");
      $(".unicorn_progress").css("visibility", "visible");
      $(".loding_more").removeClass("uniHide");
      $(".table_more").addClass("uniHide");
      $("#allDownload tbody")[0].innerHTML =
        $("#modal_tbody tbody")[0].innerHTML;
      let pro = new UnicornProduct(document.URL);
      pro.exportExcelCallback = exportExcel;
      pages = commentsMap[id].page;
      setTimeout(() => {
        pro.getComments(commentsMap[id], "click", "Infinity");
      }, 100);
      // exportExcel("modal_tbody");
    });

  // 重置
  $("#unicorn_modal .filter_Clear")
    .unbind("click")
    .click(() => {
      if (sessionStorage.getItem("loading")) return;
      $(".table_description").hide();

      const obj = {
        Verified: "all_reviews",
        keywords: "",
        sort: "helpful",
        star: "all_stars",
      };
      $(".filter_Keywords input").val("");

      $(".Verified_select").text("All");
      $(".Star_select").text("All");
      $(".sort_select").text("All");
      for (const k in obj) {
        commentsMap[id][k] = obj[k];
      }

      $("#unicorn_modal tbody").empty();
      const pro = new UnicornProduct(document.URL);
      // $("#uniPopupPro").draggable({ disabled: true });
      $("#unicorn_modal").css("display", "flex");
      commentsMap[id] = {
        page: 1,
        id: id,
        Verified: "all_reviews",
        keywords: "",
        sort: "helpful",
        star: "all_stars",
        arr: [],
      };
      $(".review_rating").text("");
      pro.getComments(commentsMap[id]);
      e.stopPropagation();
    });
  if (document.getElementsByClassName("input_keywords")) {
    $(".input_keywords")
      .off()
      .on("change", (e) => {
        if (sessionStorage.getItem("loading")) return;

        $("#unicorn_modal .filter_Search").click();
      });
    // document.getElementsByClassName('input_keywords')[0].addEventListener('change', function (ev) {
    //   console.log(ev)
    // })
  }
};
const chartEvents = () => {
  $(".uni_Chart_content .tab_list")
    .off()
    .on("click", "li", function () {
      $(".tab_list li").removeClass("tab_check");
      $(this).addClass("tab_check");
      echartsCallback("UniChart", {
        title: {
          text: "",
        },
        tooltip: {},
        legend: {
          data: ["销量"],
        },
        xAxis: {
          data: ["衬衫", "羊毛衫", "雪纺衫", "裤子", "高跟鞋", "袜子"],
        },
        yAxis: {},
        series: [
          {
            name: "销量",
            type: "bar",
            data: [5, 20, 36, 10, 10, 20],
            barWidth: "10%",
            itemStyle: {
              // normal:{
              barBorderRadius: [6, 6, 0, 0],
              // },
              color: {
                type: "linear",
                x: 0,
                y: 0,
                x2: 0,
                y2: 1,
                colorStops: [
                  {
                    offset: 0,
                    color: "#9127FD", // 0% 处的颜色
                  },
                  {
                    offset: 1,
                    color: "#DD20FA", // 100% 处的颜色
                  },
                ],
                global: false, // 缺省为 false
              },
            },
          },
        ],
      });
    });
  $(".uni_Historical_data .unicorn_close")
    .off()
    .on("click", () => {
      $(".uni_Historical_data").hide();
    });
};
const echartsCallback = (id, option) => {
  const el = document.getElementById(id);
  if (echarts.getInstanceByDom(el)) {
    echarts.dispose(el);
  }
  const productChart = echarts.init(el);

  // 指定图表的配置项和数据

  // 使用刚指定的配置项和数据显示图表。
  productChart.setOption(option);
};

/**
 * 复制文本
 * @param {string} text 复制的内容
 * @param {() => void} success 成功回调
 * @param {(tip: string) => void} fail 出错回调
 */
function copyText(text, success = null, fail = null) {
  text = text.replace(/(^\s*)|(\s*$)/g, "");
  if (!text) {
    typeof fail === "function" && fail("复制的内容不能为空！");
    return;
  }
  const id = "the-clipboard";
  /**
   * 粘贴板节点
   * @type {HTMLTextAreaElement}
   */
  let clipboard = document.getElementById(id);
  if (!clipboard) {
    clipboard = document.createElement("textarea");
    clipboard.id = id;
    clipboard.readOnly = true;
    clipboard.style.cssText =
      "font-size: 15px; position: fixed; top: -1000%; left: -1000%;";
    document.body.appendChild(clipboard);
  }
  clipboard.value = text;
  clipboard.select();
  clipboard.setSelectionRange(0, text.length);
  const state = document.execCommand("copy");
  if (state) {
    typeof success === "function" && success("成功");
  } else {
    typeof fail === "function" && fail("复制失败");
  }
}

function getStringByte(str) {
  var byteLen = 0,
    len = str.length;
  if (str) {
    for (var i = 0; i < len; i++) {
      if (str.charCodeAt(i) > 255) {
        byteLen += 2;
      } else {
        byteLen++;
      }
    }
    return byteLen;
  }
}
// window.unload = function () {
//   const updateFun = updateProduct();

//   updateFun({
//     method: "POST",
//     success: (res) => {
//       console.log(res);
//     },
//     error: (err) => {
//       console.log(err);
//     },
//   });
// };
// console.log(echarts);
